C
C	CLI.INC
C
C	THIS FILE DEFINES INTERFACE TO DCL CLI ROUTINES.
C

C
C	ACTUAL CLI REQUESTS ARE DEFINED IN A MACRO ROUTINE (WHICH
C	CONSISTS OF CLI MACROS). THE ADDRESS OF EACH REQUEST IS
C	RECORDED IN AN ARRAY WHICH FORTRAN ROUTINES REFERENCE
C	WHEN A CLI CALL BACK IS NECESSARY. THE FOLLOWING PARAM-
C	ETER STATEMENTS DEFINE OFFSETS (LONGWORD) WITHIH THIS
C	LABELED COMMON.
C


	PARAMETER INITIALIZE_PARSE	= 0	! OFFSET TO INIT PARSE ADDRESS
	PARAMETER PARSE_COMMAND		= 1	! OFFSET TO GET COMMAND ADDRESS
	PARAMETER PARSE_FILE_AND_QUALIFIERS = 2 ! OFFSET TO GET PARAMETER ADDRESS
	PARAMETER END_FILE_PROCESSING	= 3	! OFFSET TO END PARAMETER 1 ADDRESS
	PARAMETER GET_FILE_NAME		= 4	! RETRIEVE FILE NAME FOLLOWING /OUTPUT
	PARAMETER GET_ASCII_VALUE	= 5	! RETRIEVE DEVICE NAME FOLLOWING /PRINT
	PARAMETER PARSE_COMMAND_QUALIFIERS = 6	! OFFSET TO GET COMMAND QUALIFIERS ADDRESS


C
C	REQUEST ARRAY CONTAINS ADDRESSES OF VARIOUS REQUEST BLOCKS.
C	THESE ADDRESSES ARE REFERENCED BY THE PREVIOUS PARAMETER
C	DEFINITIONS.
C

	INTEGER*4 REQUEST(0:PARSE_COMMAND_QUALIFIERS)

	COMMON /CLI_REQUEST/ REQUEST

C
C	THE NEXT PARAMETER DEFINES SIZE OF CLI WORK AREA AND
C	DEFINES OFFSETS INTO CLI REQUEST BLOCKS. THESE
C	DEFINITIONS COME FROM (SYS$LIBRARY:LIB.MLB/EXT=$CLIDEF).
C
	PARAMETER CLI$K_WORKAREA	= '80'X
	PARAMETER CLI$W_RQSIZE		= '08'X
	PARAMETER CLI$A_RQADDR		= '0C'X
	PARAMETER CLI$Q_RQDESC		= CLI$W_RQSIZE
	PARAMETER CLI$_BADTEXT		= '381B0'X

C
C	DEFINE WORK AREAS NEEDED BY CLI INTERFACE ROUTINES.
C

	INTEGER*4 WORK_AREA(0:CLI$K_WORKAREA/4)
	INTEGER*4 CONTEXT_AREA(0:2)

	COMMON /CLI_DATA/ CONTEXT_AREA, WORK_AREA

