	SUBROUTINE OPEN_ERROR(FAB,ERROR)
	IMPLICIT INTEGER*4 (A-Z)
C++
C
C FUNCTION:
C
C	THIS ROUTINE IS CALLED AS AN AST TO REPORT AN ERROR OPENING
C	AN INPUT FILE.
C
C INPUTS:
C
C	FAB		FILE ACCESS BLOCK FOR BAD FILE
C	ERROR		RMS ERROR CODE
C
C OUTPUTS:
C
C	THE ERROR IS REPORTED
C
C--

	INCLUDE 'LIBRARY:SHR.DEF/NOLIST'
	INCLUDE 'LIBRARY:RMS.DEF/NOLIST'

	PARAMETER CLI_SUBSYSTEM		= '00030000'X

	IF(%LOC(ERROR) .NE. RMS$_NMF)
	1  CALL RMS_ERROR(FAB, (SHR$_OPENIN .OR. CLI_SUBSYSTEM))
	RETURN
	END

	SUBROUTINE CREATE_ERROR(FAB,ERROR)
	IMPLICIT INTEGER*4 (A-Z)
C++
C
C FUNCTION:
C
C	THIS MODULE IS CALLED TO REPORT AN ERROR CREATING THE
C	OUTPUT FILE.
C
C INPUTS:
C
C	FAB		FILE ACCESS BLOCK FOR BAD FILE
C	ERROR		RMS ERROR CODE
C
C OUTPUTS:
C
C	THE ERROR IS REPORTED
C
C SIDE EFFECTS:
C
C	THIS IS A FATAL ERROR CAUSING THE COMMAND TO BE ABORTED.
C--

	INCLUDE 'LIBRARY:SHR.DEF/NOLIST'

	PARAMETER CLI_SUBSYSTEM		= '00030000'X

	CALL RMS_ERROR(FAB, (SHR$_OPENOUT .OR. CLI_SUBSYSTEM))
	RETURN
	END


	SUBROUTINE CLOSE_INPUT_ERROR(FAB,ERROR)
	IMPLICIT INTEGER*4 (A-Z)
C++
C
C FUNCTION:
C
C	THIS ROUTINE IS CALLED TO REPORT AN ERROR CLOSING AN INPUT
C	FILE.
C
C INPUTS:
C
C	FAB		FILE ACCESS BLOCK FOR BAD FILE
C	ERROR		RMS ERROR CODE
C
C OUTPUTS:
C
C	THE ERROR IS REPORTED
C
C--

	INCLUDE 'LIBRARY:SHR.DEF/NOLIST'

	PARAMETER CLI_SUBSYSTEM		= '00030000'X

	CALL RMS_ERROR(FAB, (SHR$_CLOSEIN .OR. CLI_SUBSYSTEM))
	RETURN
	END

	SUBROUTINE CLOSE_OUTPUT_ERROR(FAB,ERROR)
	IMPLICIT INTEGER*4 (A-Z)
C++
C
C FUNCTION:
C
C	THIS ROUTINE IS CALLED TO REPORT AN ERROR IN CLOSING THE
C	OUTPUT FILE.
C
C
C INPUTS:
C
C	FAB		FILE ACCESS BLOCK FOR BAD FILE
C	ERROR		RMS ERROR CODE
C
C OUTPUTS:
C
C	THE ERROR IS REPORTED
C
C--

	INCLUDE 'LIBRARY:SHR.DEF/NOLIST'

	PARAMETER CLI_SUBSYSTEM		= '00030000'X

	CALL RMS_ERROR(FAB, (SHR$_CLOSEOUT .OR. CLI_SUBSYSTEM))
	RETURN
	END

	SUBROUTINE GET_ERROR(RAB,ERROR)
	IMPLICIT INTEGER*4 (A-Z)
C++
C
C FUNCTION:
C
C	THIS MODULE IS CALLED TO REPORT AN ERROR READING INPUT FILE.
C
C INPUTS:
C
C	RAB		RECORD ACCESS BLOCK FOR INPUT FILE
C	ERROR		RMS ERROR CODE
C
C OUTPUTS:
C
C	THE ERROR IS REPORTED.
C
C--

	INCLUDE 'LIBRARY:FAB.DEF/NOLIST'
	INCLUDE 'LIBRARY:RAB.DEF/NOLIST'
	INCLUDE 'LIBRARY:RMS.DEF/NOLIST'

	PARAMETER CLI_SUBSYSTEM		= '00030000'X

	INTEGER*4 ERROR
	INTEGER*4 FAB_ADDRESS

	LOGICAL*1 RAB(0:RAB$C_BLN-1)

C
C	END OF FILE IS NOT CONSIDERED AN ERROR
C

	IF(%LOC(ERROR) .NE. RMS$_EOF) THEN

C
C	  GET CORRESPONDING FAB AND MOVE ERROR INFO INTO FAB.
C

	  CALL COPY(4,
	1           RAB(RAB$L_FAB),
	2           FAB_ADDRESS)

	  CALL COPY(8,
	1           RAB(RAB$L_STS),
	2           %VAL(FAB_ADDRESS+FAB$L_STS))

	  CALL RMS_ERROR(%VAL(FAB_ADDRESS),
	1                (SHR$_READERR .OR. CLI_SUBSYSTEM))

	  END IF

	RETURN
	END

	SUBROUTINE PUT_ERROR(RAB,ERROR)
	IMPLICIT INTEGER*4 (A-Z)
C++
C
C FUNCTION:
C
C	THIS MODULE IS CALLED TO REPORT AN ERROR WRITING THE OUTPUT FILE.
C
C INPUTS:
C
C	RAB		RECORD ACCESS BLOCK FOR INPUT FILE
C	ERROR		RMS ERROR CODE
C
C OUTPUTS:
C
C	THE ERROR IS REPORTED.
C
C SIDE EFFECTS:
C
C	THIS IS A FATAL ERROR CAUSING A COMMAND ABORT.
C
C--

	INCLUDE 'LIBRARY:FAB.DEF/NOLIST'
	INCLUDE 'LIBRARY:RAB.DEF/NOLIST'

	PARAMETER CLI_SUBSYSTEM		= '00030000'X

	INTEGER*4 ERROR
	INTEGER*4 FAB_ADDRESS

	LOGICAL*1 RAB(0:RAB$C_BLN-1)

C
C	GET CORRESPONDING FAB AND MOVE ERROR INFO INTO FAB.
C

	CALL COPY(4,
	1         RAB(RAB$L_FAB),
	2         FAB_ADDRESS)

	CALL COPY(8,
	1         RAB(RAB$L_STS),
	2         %VAL(FAB_ADDRESS+FAB$L_STS))

	CALL RMS_ERROR(%VAL(FAB_ADDRESS),
	1              (SHR$_WRITEERR .OR. CLI_SUBSYSTEM))

	RETURN
	END


	SUBROUTINE MSC_RAB_ERROR(RAB,ERROR)
	IMPLICIT INTEGER*4 (A-Z)
C++
C
C FUNCTION:
C
C	THIS MODULE IS CALLED TO REPORT A MISCELLANEOUS ERROR INVOLVING
C	THE RECORD ACCESS BLOCK.
C
C INPUTS:
C
C	RAB		RECORD ACCESS BLOCK FOR INPUT FILE
C	ERROR		RMS ERROR CODE
C
C OUTPUTS:
C
C	THE ERROR IS REPORTED.
C
C--

	INCLUDE 'LIBRARY:FAB.DEF/NOLIST'
	INCLUDE 'LIBRARY:RAB.DEF/NOLIST'

	PARAMETER CLI_SUBSYSTEM		= '00030000'X

	INTEGER*4 ERROR
	INTEGER*4 FAB_ADDRESS

	LOGICAL*1 RAB(0:RAB$C_BLN-1)

C
C	GET CORRESPONDING FAB AND MOVE ERROR INFO INTO FAB.
C

	CALL COPY(4,
	1         RAB(RAB$L_FAB),
	2         FAB_ADDRESS)

	CALL COPY(8,
	1         RAB(RAB$L_STS),
	2         %VAL(FAB_ADDRESS+FAB$L_STS))

	CALL RMS_ERROR(%VAL(FAB_ADDRESS),
	1              (SHR$_RMSERROR .OR. CLI_SUBSYSTEM))

	RETURN
	END

	SUBROUTINE RMS_ERROR(FAB,ERROR)
	IMPLICIT INTEGER*4 (A-Z)
C++
C
C FUNCTION:
C
C	THIS MODULE REPORTS ALL RMS ERRORS.
C
C INPUTS:
C
C	FAB		FILE ACCESS BLOCK CORRESPONDING TO FILE ON WHICH
C			ERROR OCCURED.
C
C	ERROR		PRIMARY ERROR CODE
C
C IMPLICIT INPUTS:
C
C	FAB(FAB$L_STS)	CONTAINS RMS ERROR CODE
C	FAB(FAB$L_STV)	CONTAINS ADDITIONAL ERROR INFO
C	FAB(FAB$L_NAM)	CONTAINS ADDRESS OF NAM BLOCK
C
C OUTPUTS:
C
C	THE FILE NAME IS EXTRACTED FROM THE MOST DESCRIPTIVE LOCATION
C	( RESULTANT STRING, EXPANDED STRING, OR FILE NAME FIELD IN THAT
C	ORDER) AND ADDED TO ERROR MESSAGE. THE MESSAGE IS THEN SIGNALED.
C
C--

	INCLUDE 'LIBRARY:FAB.DEF/NOLIST'
	INCLUDE 'LIBRARY:NAM.DEF/NOLIST'

	INTEGER*4 NAME_DESCR(2)			! DESCRIPTOR FOR FILE NAME
	INTEGER*4 NAM_ADDRESS			! ADDRESS OF NAM BLOCK
	INTEGER*4 RSL				! LENGTH OF RESULTANT STRING
	INTEGER*4 ESL				! LENGHT OF EXPANDED STRING
	INTEGER*4 FNS				! LENGTH OF FILE NAME STRING
	INTEGER*4 STS_VALUE			! PRIMARY RMS ERROR CODE
	INTEGER*4 STV_VALUE			! SECONDARY RMS ERROR CODE

	LOGICAL*1 FAB(0:FAB$C_BLN-1)

C
C	GET FNS FROM FAB
C

	CALL COPY(1,
	1         FAB(FAB$B_FNS),
	2         FNS)

C
C	NOW RESET ESL AND RSL IN CASE THERE IS NO NAM BLOCK PRESENT
C	AND THIS ROUTINE HAS BEEN CALLED BEFORE.
C

	RSL = 0
	ESL = 0

C
C	GET ADDRESS OF NAM BLOCK FROM FAB
C

	CALL COPY(4,
	1         FAB(FAB$L_NAM),
	2         NAM_ADDRESS)

	IF(NAM_ADDRESS .NE. 0) THEN

C
C	  NAM BLOCK PRESENT
C

	  CALL COPY(1,
	1           %VAL(NAM_ADDRESS+NAM$B_RSL),
	2           RSL)

	  CALL COPY(1,
	1           %VAL(NAM_ADDRESS+NAM$B_ESL),
	2           ESL)

	  END IF

	IF(RSL .NE. 0) THEN

C
C	  RESULTANT STRING PRESENT. USE THIS FOR FILE NAME SINCE THIS IS
C	  MOST DESCRIPTIVE.
C

	  NAME_DESCR(1) = '010E0000'X .OR. RSL

	  CALL COPY(4,
	1           %VAL(NAM_ADDRESS+NAM$L_RSA),
	2           NAME_DESCR(2))

	ELSE IF (ESL .NE. 0) THEN

C
C	  RESULTANT STRING NOT PRESENT, BUT EXPANDED STRING IS. WE WILL
C	  SETTLE FOR THE EXPANDED STRING.
C

	  NAME_DESCR(1) = '010E0000'X .OR. ESL

	  CALL COPY(4,
	1           %VAL(NAM_ADDRESS+NAM$L_ESA),
	2           NAME_DESCR(2))

	ELSE

C
C	  NEITHER THE EXPANDED STRING NOR THE RESULTANT STRING IS
C	  PRESENT OR THERE IS NO NAM BLOCK. WE ARE FORCED TO TAKE
C	  THE FILE NAME FROM THE FAB. THIS IS OUR LAST CHOICE SINCE
C	  PART OF THE NAME MAY BE OMMITTED AND NO TRANSLATIONS HAVE
C	  BEEN DONE.
C

	  NAME_DESCR(1) = '010E0000'X .OR. FNS

	  CALL COPY(4,
	1           FAB(FAB$L_FNA),
	2           NAME_DESCR(2))

	  END IF

	CALL COPY(4,
	1         FAB(FAB$L_STS),
	2         STS_VALUE)

	CALL COPY(4,
	1         FAB(FAB$L_STV),
	2         STV_VALUE)

	CALL LIB$SIGNAL(%VAL(ERROR),
	1               %VAL(1),
	2               NAME_DESCR,
	3               %VAL(STS_VALUE),
	4               %VAL(STV_VALUE))

	RETURN
	END

