			 Rat-dcl

	 A rational to Dcl command language translator.




    We have all seen the following responses: 

       Thank you for your comments and suggestions. We will
       consider .... in a future major release of .... 


    This  language  translator  is proof that one need not put up with
    such nonsense. Using Yacc and  Lex  over  a  single  weekend,  the
    following  language  was created. There is one nice feature of the
    DCL command language:  its  not  the  worst  machine  language  to
    translate to, its just horrible to write in it. 

    Statements:

        for(stat;condition;stat) statement_list
          break
	rof

	if(condition) statement_list
	elseif(condition) statment_list
	else statement_list
	fi

	variable = expr
        variable := expr
	variable == expr
        variable :== expr

	variable++
	variable--

    A statement_list is either of  two  forms.  It  may  be  a  single
    statement  in  which  case  it appears by itself. It may be one or
    more statements enclosed in a bracketing construct. 

    An if block bracket looks as follows:

	if (...)   then                         if (...) then
	   stats                or                 stats
	fi                                      elseif (...) then
						   stats
						else
						   stats
						fi

    A for block bracket looks as follows:

	for(...;...;...) do
	   stats
	rof

    In  order  to  do  away  with needing semicolons at the end of the
    line, and also permitting null statements, the words DO  and  THEN
    must  be  on  the  same  line  with  their  corresponding clauses.
    However, line continuation as disscussed below is permitted. 

    For  C people, the word do can be { and rof can be }. But the word
    THEN must be just that as well as the word FI.

    Multiple non DCL statements may be on a line via ; separators. And
    unlike  C  and  ratfor, the for statement allows nulls only in the
    stat parts, and they may be multiple  statements  if  inclosed  in
    {}'s. Thus:

	statement;statement;...         !like this
	{statement;statement;...}       !or this if in a for statement

    Any  dcl  statement  may  be  output  (if  on  a separate line) by
    beginning it with the ubiquitous dollar  sign.  Two  ($$)  act  to
    treat  the  line  as a dcl statement, but suppresses the output of
    the $ so it can be used as data. All dcl  restrictions  and  other
    nonsense apply. This includes comment and continuation practices. 

	$Any dcl command
	$$ Any data to be given to above dec command

    Dcl command execution may  be  suppressed  if  the  translator  is
    invoked: 

	lan <in >out -n

    then  any  DCL line (begins with a single `$') will result in code
    that simply echos  the  line  to  sys$output.  However,  some  DCL
    commands  may  need  to  be  executed  as  well. Thus an escape is
    provided  such  that  any  command   that   starts   with   `$   '
    (dollar,space)  is executed. If the command begins with `$inquire'
    or `$write' it is automatically executed as well. 

    Lexical issues:

    The newline and semicolon are treated as statement  separators.  A
    backslash  `\',  if  not  in  quotes,  causes  all  text up to and
    including the newline to be  discarded.  This  is  used  for  line
    continuation.  Comments  are  the first non quoted `!' on the line
    out to the newline character. But the `!'  does  not  eat  up  the
    newline, thus ending a statement.

    Variables are passed onto  Dcl  as  they  are  except  for  quoted
    strings  that  are not following a $ marker. Here the C convention
    of escaping the quote is used: 

	"this is has a quote \" <- there"

    Variables follow the rule: start with a letter then can be any  $,
    quotemark,   letters   or  numbers,  or  an  underscore.  Function
    references to dcl lexical stuff are  passed  on  as  well.  Strict
    syntax  checking  is  actually done, even though in many cases the
    output is just an exact copy of the input. However, the  following
    transformations are done: 

       from      to            from      to            from      to
	==      .eq.            &&      .and.           eq      .eqs.
	>=      .ge.            ||      .or.            ge      .ges.
	<=      .le.                                    le      .les.
	!=      .ne.                                    ne      .nes.
	>       .gt.                                    gt      .gts.
	<       .lt.                                    lt      .lts.

Examples:


$ on error then exit 1
$ type := write sys$output
$ inquire limit "Limit"
for( {j=1; i=1} ; i<limit  ;  {j--; i++}  ) do !note multiple actions per
					       !for clause.

   if(i >15)  break                     ! Example comment
					! here.

   if (                                 \   These are comments too.
	i==5  || i==6  ||               \   Since they follow the line
	i==7  ||                        \   continuation character \.
	i==8  ||                        \   They don't need the ! either.
	i==9  || i==10 || i==11 )  then

	   $type  -                   !these are dcl continuations and comments
	   $$    "its in the big or 5-11 ",        -
	   $$     i

   elseif (i>10) then                 !the word then must be on the same line
      $type "I is > 10 and is  ",i    !with the elseif, but unfortunately, an
                                      !error does not always appear if its
				      !missing.
   else
      $type "default i and j are ",i," ",j

   fi
rof
