%{
#define register
#define short int
	int *getout();
%}
%left _AND _OR
%right '='
%left '+' '-'
%left '*' '/' '%'
%right '^'
%left UMINUS

%term LETTER SQRT LENGTH _IF  EQ COEQ NUMBER
%term _WHILE _FOR NE LE GE INCR DECR _AND _OR GTS LTS LES GES
%term _RETURN _BREAK _DEFINE DCL COEQEQ
%term EQPL EQMI EQMUL EQDIV EQREM EQEXP EQS NEQS
%term _AUTO _THEN _FI _ELSEIF _ELSE
%term QSTR

%{
#include <stdio.h>
extern  char  yytext[];
int in={0};

char string[1000]={0}, *str = {string};
char buf[3000]={0};
char *pbuf = { buf };


int ln = {0};         /* line number */
char *ss={0};
/*

If stack

   istack[istp-1]    tos   propogated label, each elseif's next try
   istack[istp-2]    nos   final label, after successful elseif, go here
   istack[istp-3]    3os   number of unsatisfied then's needing closures

for stack

   fstack[fstp-1]    tos   where to goto on done and break
   fstack[fstp-2]    nos   where to go back for more to do

*/

int istack[30] = { 0 };
int istp = {0};

int fstack[30] = { 0 };
int fstp = {0};

int newlab =0;

%}
%%
start	: 
	|  start stat tail
		 {output( $2 );}
	;

stat    :  DCL
		{$$= bundle(2,$1,"\n");}
        |
		{$$ = bundle(1,"");}
	|  incdec
		{$$ = bundle(1,$1);}
        |  LETTER '=' e
		={$$ = bundle(5,"$",$1," = ",$3,"\n")  ; }
	|  LETTER COEQ  e
		={$$ = bundle(5,"$",$1," := ",$3,"\n")  ; }
	|  LETTER COEQEQ  e
		={$$ = bundle(5,"$",$1," :== ",$3,"\n")  ; }
	|  _BREAK
		 { sprintf(pbuf,"$goto x%d\n",fstack[fstp-1]);
		   $$ = bundle(1,pbuf);
		   upbuf(pbuf);
		}
	|  '{' slist '}'
		={ $$ = $2; }
	|  _THEN
		 {     istack[istp-3]++    ;}
	   slist _FI
		={ $$ = $3; }
	|  error
		={              ; }
	|  _IF
		 { istack[istp++] = 0; /* reserve cell */
		   istack[istp++] = ++newlab;
		   istack[istp++] = ++newlab;}
	'(' re  ')'
		 { sprintf(pbuf,") then goto x%d\n",istack[istp-1]);
		   $$ = bundle(3,"$if .not.(",$4,pbuf);
		   upbuf(pbuf);
                 }
	    stat
		 { int t1,t2;
			 t1 = istack[--istp]; t2 = istack[--istp];
			 --istp;  /* unreserve cell */
			 sprintf(pbuf,"$x%d:\n$x%d:\n",t1,t2);
			 $$ = bundle(3,$6,$7,pbuf);
			 upbuf(pbuf);
		 }
	|  _ELSEIF

	'(' re  ')'
		 { int temp; char *tstr;  temp = istack[istp-1];
		   istack[istp-1] = ++newlab;
                   sprintf(pbuf,"$goto x%d\n$x%d:\n$if .not.(",
						istack[istp-2],  temp);
		   tstr = pbuf;
		   upbuf(pbuf);
		   sprintf(pbuf,") then goto x%d\n",istack[istp-1]);
		   $$ = bundle(3,tstr,$3,pbuf);
		   upbuf(pbuf);
                 }
	    stat
		 {
		    $$ = bundle(2,$5,$6);
		 }
	|  _ELSE


		 { int temp; temp = istack[istp-1];
		   istack[istp-1] = ++newlab;
		   sprintf(pbuf,"$goto x%d\n$x%d:\n",
						istack[istp-2],  temp);
		   $$ = bundle(1,pbuf);
		   upbuf(pbuf);
                 }
	    stat
		 {
		    $$ = bundle(2,$2,$3);
		 }
	/*    1   2   3    4   */
	|   _FOR '(' stat ';'
			/*  5   */
		 {
		   fstack[fstp++] = ++newlab;
		   fstack[fstp++] = ++newlab;
		    $$ = bundle(1,$3);
		}
/*              6    7   8    9   10  */
	     relexp ';' stat ')' stat
		  {
		   char *tstr; sprintf(pbuf,"$x%d:\n", fstack[fstp-2]);
		   tstr = pbuf; upbuf(pbuf);

		    sprintf(pbuf,") then goto x%d\n", fstack[fstp-1]);
		    $$ = bundle(7,$5,tstr,"$if .not.(",$6,pbuf,$10,$8);
		    upbuf(pbuf);
		  }
	  /*  12   */
	     endfor
		{
		   sprintf(pbuf,"$goto x%d\n$x%d:\n"
					,fstack[fstp-2],fstack[fstp-1]);
		   $$ = bundle(2,$11,pbuf);
		   upbuf(pbuf);
		   fstp = fstp - 2;
		}
         ;
endfor  :
	;
slist	:  stat
	|  slist tail stat
		= {bundle(2,$1,$3) ;}
	;

tail	:  '\n'
		={ln++;}
	|  ';'
	;
re      : relexp
		{$$ = bundle(1,$1);}
	|  re conjop relexp
		{$$ = bundle(3,$1,$2,$3);}

conjop  :  _AND
		{ $$ = bundle(1,".and.") ;}
	|  _OR
		{ $$ = bundle(1,".or.") ;}
	;
relexp  :  e EQ e
		{ $$ = bundle(3,$1,".eq.",$3) ;}
	|  e NE e
		{ $$ = bundle(3,$1,".ne.",$3) ;}
	|  e '<' e
		{ $$ = bundle(3,$1,".lt.",$3) ;}
	|  e '>' e
		{ $$ = bundle(3,$1,".gt.",$3) ;}
	|  e LE e
		{ $$ = bundle(3,$1,".le.",$3) ;}
	|  e GE e
		{ $$ = bundle(3,$1,".ge.",$3) ;}
	|  e LTS e
		{ $$ = bundle(3,$1,".lts.",$3) ;}
	|  e GTS e
		{ $$ = bundle(3,$1,".gts.",$3) ;}
	|  e GES e
		{ $$ = bundle(3,$1,".ges.",$3) ;}
	|  e LES e
		{ $$ = bundle(3,$1,".les.",$3) ;}
	|  e EQS e
		{ $$ = bundle(3,$1,".eqs.",$3) ;}
	|  e NEQS e
		{ $$ = bundle(3,$1,".nes.",$3) ;}
	|  e
		{ $$ = bundle(1,$1) ;}
	;

e	:  e '+' e
		{ $$ = bundle(3,$1,"+",$3) ;}
	|  e '-' e
		{ $$ = bundle(3,$1,"-",$3) ;}
	| '-' e		%prec UMINUS
		{ $$ = bundle(2,"0-",$2) ;}
	| '~' e         %prec UMINUS
		{$$ = bundle(3,".not.(",$2,")");}
	|  e '*' e
		{ $$ = bundle(3,$1,"*",$3) ;}
	|  e '/' e
		{ $$ = bundle(3,$1,"/",$3) ;}
	|  LETTER '(' cargs ')'
		= ;
	|  LETTER '(' ')'
		= ;
	|  NUMBER
		{$$ = bundle(1,$1);}
	|  LETTER
		{$$ = bundle(1,$1);}
	| LENGTH '(' e ')'
		  {$$ = bundle(3,"'f$len(",$2,")'");}
	|  '(' re ')'
		  { $$ = bundle(3,"(",$2,")"); }
	| QSTR
		{$$ = bundle(3,"\"",$1,"\"");}
	| incdec
		{$$ = bundle(1,$1);}
	;

incdec  :  LETTER INCR
		{ $$ = bundle(5,"$",$1,"=",$1,"+1\n") ;}
	|  LETTER DECR
		{ $$ = bundle(5,"$",$1,"=",$1,"-1\n") ;}
	;
cargs   :  eora                 /* currently not implemented */
	|  cargs ',' eora
		= ;
	;
eora:	  e
	;

%%
# define error 256
# define b_sp_max 3000

int sargc={0};
int ifile={0};
char **sargv={0};

int b_space [ b_sp_max ]={0};
int * b_sp_nxt = { b_space };

int bdebug = 0;
bundle(a){
	int i, *p, *q;

	p = &a;
	i = *p++;
	q = b_sp_nxt;
	if( bdebug ) printf("bundle %d elements at %o\n",i,  q );
	while(i-- > 0){
		if( b_sp_nxt >= & b_space[b_sp_max] ) yyerror( "bundling space exceeded" );
		* b_sp_nxt++ = *p++;
	}
	* b_sp_nxt++ = 0;
	yyval = q;
	return( q );
}

upbuf(p)   char *p; {
int i;
i=strlen(p);
pbuf = p + i + 5;
}
routput(p) int *p; {
	if( bdebug ) printf("routput(%o)\n", p );
	if( p >= &b_space[0] && p < &b_space[b_sp_max]){
		/* part of a bundle */
		while( *p != 0 ) routput( *p++ );
	}
	else printf("%s",p);        /* character string */
}

output( p ) int *p; {
	routput( p );
	b_sp_nxt = & b_space[0];
	printf( "\n" );
	fflush(stdout);
	pbuf = buf;
}


yyerror( s ) char *s; {
	char *tok; tok = yytext;
	if(strlen(tok)==1 && tok[0]== '\n')
		tok = "end of line";
	eprintf("%s on line %d at `%s'\n", s ,ln+1,tok);
	exit(0);
}

yyinit(argc,argv) int argc; char *argv[];{
	sargv=argv;
	sargc= -- argc;
	if(sargc == 0)in=stdin;
	else if((in = fopen(sargv[1],"r")) == NULL)
		yyerror("cannot open input file");
	ifile = 1;
	ln = 0;
	ss = sargv[1];
}
int *getout(){
  if(istp >  0) eprintf("%d levels of unterminated if blocks\n",istp/3);
  if(fstp >  0) eprintf("%d levels of unterminated for blocks\n",fstp/2);
	fflush(stdout);
	exit(0);
}

extern *yyin,*yyout;
main(argc, argv)
char **argv;

{
	int p[2];
yyin = stdin; yyout=stdout;


	if (argc > 1 && *argv[1] == '-') {
		if((argv[1][1] == 'd')||(argv[1][1] == 'c')){
			yyinit(--argc, ++argv);
			yyparse();
			exit(0);
		}
		if(argv[1][1] != 'l'){
			printf("unrecognizable argument\n");
			fflush(stdout);
			exit(0);
		}
		argv[1] = "lan:lib.b";
	}
		yyinit(argc, argv);
		yyparse();
		exit(0);
}
