


    Vax Mp                      August 22, 1981                       Vax Mp


    
    
    
    
    
    
    
    
    
                    Vax Mp   -      Macro Processor
    
    
    
       Part I       1.      Introduction
    
       Part II      2.      What Mp does
                    2.1         The pass
         The Mp     2.2         The macros
       Expander     2.3         Treatment of non macros
                    2.4         Variables and Conditionals
                    2.5         More internal statements
                    2.6         Switches
                    2.7         Macro definitions and arguments
                    2.8         The string stack
                    2.9         Macro argument operators
                    3.      Operating instructions
    
       Part III     4.      Built in macros
                    4.1         Language description
      Using the     4.2         Program structure.
    Mp language     4.3         Data types
                    4.4         Constants
                    4.5         Declarative statements
                    4.6         Executable statements
                    4.7         Vax opcodes and Mp variables
                    4.8         Notes
                    4.9         Optimizer
                    5.      Macro summary
    
       Part IV      6.      Alternate built in macro libraries
                    6.1         Modifications to internals
                    7.      Examples

















    Vax Mp                      August 22, 1981                       Vax Mp


    
    1.  Introduction
    
    Mp is a macro expander. This document describes the version implemented
    on  the  pdp-11  (or  compatibility mode in the vax). It is intended to
    support a systems  programming  language  for  the  Vax.  Since  the  C
    language  is  not  universily available on Vax systems, and in at least
    one version is not compatible with Vms external names; and Bliss  costs
    money  and  is difficult to learn, programmers are still tempted to use
    assembly language. Therefore, this simple macro processor  provides  an
    alternative to macro-32 which can operate on data at the machine level,
    while  still  supporting  higher  level language constructs. Part II of
    this document deals with the use of Mp strictly as a  macro  processor;
    Part  III  describes  an  implemented  language using Mp. The reader is
    assumed to be familiar with macro-32 and especially the use of  macros.
    The  documentation  of  the implemented language is short by design. In
    any language which permits direct low  level  machine  operations,  the
    user  must  be  able  to  predict  the  resultant  code each high level
    statement generates. 
    
    The format of input  is  compatible  with  the  assembler  on  the  Vax
    (Macro-32).  However,  the  arguments  inside  of macro definitions are
    referenced by number rather than symbolically. Labels and comments  are
    compatible  (i.e.  the  `:'  and  `;' delimiters for labels and comment
    fields). One minor restriction is  that  the  `;'  must  have  a  space
    preceding  it in order to begin the comment field. Parameters passed to
    macros have the same nesting rules (i.e. <>'s etc.) but  there  are  no
    Keyword  macros.  The  ^z...z syntax is supported and the form "..." is
    additionally allowed. Arguments have selector  operators  which  permit
    extracting  portions  of  a  single  argument  or  referencing multiple
    arguments (e.g. arguments 2 thru arg  n,  where  n  is  the  number  of
    arguments passed to the macro). 
    
    In  addition,  there  is  a string stack which may be accessed globally
    with operators for referencing absolute elements and elements  relative
    to  the top of the stack. The stack may be divided into two stacks with
    two stack pointers if  desired.  The  elements  on  the  stack  may  be
    assigned  to  the  local parameters of the macro. A method is available
    for generating labels of the form xxxnnn where nnn is a decimal  number
    and  xxx is user definable (0-25 chars). There are 50 integer variables
    30 of which can be accessed directly, and all 50 indirectly.  They  can
    be  used  as  a numerical stack or as an index into the string stack. A
    simplistic symbol table mechanisim exists  with  various  operators  to
    access  the  type and/or existence of symbols. Various statements exist
    for the conditional expansion of code either from within macros  or  at
    the statement level.
    
    The syntax of internal statements in this processor is cryptic, but for
    a good reason - speed. Any  interpreter  that  presents  a  high  level
    language  must  pay  a  price  at translation time. Past experience has
    shown the advantages of such a system are outweighed  by  the  cost  in
    performace.  For  example, Dec's supermac is written in a `nicer' macro
    language (e.g. symbolic arguments etc.) but has assembly times  of  3-5



                                      -2-                                1.0



    Vax Mp                      August 22, 1981                       Vax Mp


    minutes  per  300  lines  of  code. If macro-32 had included a few high
    level statements (such as if and loop block structured statements) this
    processor might never have been created (or at least left to the pdp-11
    where it started some 6 years ago when there was only threaded  fortran
    or  macro-11).  The language which is implemented using this system can
    translate 300 lines of code on the vax to intermediate form in about 25
    seconds (a very large module). And, since no macros  are  presented  to
    macro-32,  it  creates  object  modules  in under 5 seconds. (Why 5 rms
    macros take  25 seconds to expand is also beyond the  understanding  of
    meager mortals). 
    
    The  language imlemented is a typeless statement language. It resembles
    C with respect to storage class (auto, register, parameters, etc.)  and
    supports  vax machine opcodes operating on scalar variables. Structures
    and arrays are featured as well as a powerful function call  which  may
    be   nested  (e.g.  func[a,b,func[...]])  and  include  expressions  or
    character string literals. Bit  arrays  are  supported  using  the  vax
    extract  and  insert  bit  instructions.  For  convience,  an intrinsic
    function is supplied to create call by reference, whereas call by value
    (using stack generated arguments) is the  norm.  Except  for  cases  of
    deliberate  abuse  and the above call by reference routine (to be fixed
    soon), all code is position  independant  (unlike  the  Whitesmithes  C
    compiler).  Scope  is as in C, that is, there are local stack variables
    in separate functions that optionally return values and  external  data
    sharable  among  all  functions  in  a file but hidden from the outside
    world. Expressions are flat however, that is, no ()'s nor heirarchy  of
    operators.  Direct  manipulation  of  registers  are  permitted and the
    translator will use a restricted range of registers for temporaries. 
    
    If the user does not directly violate the register usage rules, then an
    optional optimizer will generate fairly good code. It is  not  globally
    optimized,  but results in better code that Pascal and about as good or
    better than the Whitesmithes C compiler. These measurements  are  based
    soley  on  high  level coding, and don't attempt to measure what can be
    accomplished using direct vax opcodes at critical  places.  The  output
    code  is  not  commented,  but  uses  the  same symbolic names given to
    declared variables. Thus if a user were forced to code at the  macro-32
    level,  he  could use this translator and later comment the output code
    and produce reasonable results. 
    
    Other possible uses for this processor:  Partial  cross  assembly  from
    macro11 to macro32 or cross assemblers for other machines.
    
    
    











                                      -3-                                1.0



    Vax Mp                      August 22, 1981                       Vax Mp


    2.  What Mp does
    
    
    
    2.1  The pass
    
    Mp  reads  the entire source file one time and acts as a filter copying
    from its input to its output until it detects either an opcode that  is
    an  internal  code or a user defined macro, or it detects an assignment
    statement. Macros are recursively expanded (i.e. calls to the statement
    routine for each line of the macro) until a line that is  not  a  macro
    nor  an  internal opcode are detected, at which time the line is output
    unmodified. Nesting  of  macro  calls  is  handled  much  the  same  as
    macro-32. 
    
    Note  that  mostly  all string matching has been made case insensitive;
    where there are exceptions, they will be noted.
    
    
    
    2.2  The macros
    
    Mp  accepts  macros  from  various  places. The order in which they are
    entered into the macro name table  determines  which  definition  takes
    precedence  when the macro is multiply defined. The following lists the
    the search order for opcodes. 
    
    
    a.   The first set of names  are  the  conditionals  (these  are  hard-
         coded).
    
    b.   The file which contains the source to be processed, may have macro
         definitions  (if  the  /lm  switch is specified - see later). They
         must precede all other source  code  and  be  separated  from  the
         source by a line with a slash `/' alone in column 1.
    
    c.   One  macro  library may be specified and is a file of macros whose
         file-name is determined by Mp according the  following  rule.  The
         default  file-name is "[1,1]mplib.mac". The /ml switch changes the
         default name to "[your-directory]mplib.mac". A command-line option
         allows the setting of any file name in place of the defaults.  The
         /ml switch then is meaningless. 
    
    d.   Built into Mp is a default set of macro definitions  (loaded  from
         an  overlay  makes processing faster). The loading of these may be
         suppressed by the /ni switch.
    









                                      -4-                                2.2



    Vax Mp                      August 22, 1981                       Vax Mp


    2.3  Treatment of non macros
    
    Normally,  any statement not recognized by Mp is copied directly to the
    output.  These  statements  may  be  any  Target  assembler  directives
    provided  the  label: and ;comment syntax agrees. Note that the opcode
    is what determines if the statement is a macro and that opcodes are not
    limited to the rad50 subset. However, the current implementation of  Mp
    has  additional  special case statement handling which is geared to the
    language the author has devised using Mp. This special  checking  tests
    for  assignment statements and simple machine opcodes such as clr, bit,
    etc. This level of statement parsing only  occurs  at  statement  level
    (i.e.  not  if  from  a  macro  expansion).  It  can be switched off if
    necessary (see the /na switch later on).
    
    2.3.1  Automatic macro calls
    
    At  the  start  of  translation  of  a  file,  A  macro call is invoked
    internally with the time and date as parameters. It is called as 
    
                    $$TIM dd-mmm-yyy hh:mm:ss
    
    The default library of macros will generate an  ident  statement  using
    this  capability.  The user may redefine this to anything desirable. It
    may be defined as  a  local  macro  which  will  override  the  default
    definition. 
    
    
    
    2.4 Variables and  Conditionals
    
         Mp  has  three  kinds  of  variables.  There  is  an  array of 50
         integers, a string array of 60 variable length strings, and  each
         macro  invocation  gets  20  strings.  There  are also 33 boolean
         switches. 
    
    
    2.4.1 Integer variables
    
         There  is  an  array  of 50 integers the first 30 of which can be
         accessed as V0, V1, .. V9, va, vb, ...  vu  (vwxyz  reserved)  as
         well as by address (0..30). There are operations which permit the
         inclusion  of  these  variables  (see  section  on arguments) and
         others which set them (see s%n, t%yp, s%pos, and  s%len  internal
         statements).  They  may  also be accessed indirectly (as @n for n
         0..9,a..u) so they can form  a  stack.  Only  the  first  30  are
         directly  accessible so the remaining 20 must be accessed in this
         way also. The variable vz (readonly) allways contains the  number
         of arguments passed to a macro. 
    
    
    2.4.2 Global string array variables
    
         There is a string array which can be manipulated  using  5  terse



                                      -5-                                2.4



    Vax Mp                      August 22, 1981                       Vax Mp


         statements  (all begin with ?). This array of strings can be used
         as two stacks which is very useful for storing  nested  structure
         values such as for if statement generated labels. 
    
    2.4.3 Local String variables
    
         Each  expansion  of  a macro gets 20 local string variables which
         are initialized to the actual parameters  of  the  called  macro.
         These operate recursively like high level language functions with
         local variables. Each invocation gets a new set. 
    
    2.4.4 Switches (global)
    
         There are also 33 boolean switches. These may be set or reset and
         tested.  Many have fixed meanings, but may be set and tested just
         the same. They may be set from the command line but are initially
         all off. 
    
    
    2.4.5 Conditionals
    
         A variety of conditional statements exist. There is a restriction
         on these; they cannot have labels on them. But, labels can appear
         on a line by themselves preceding these statements if desired. 
    
    a.   I%B <string> <statement>  <else-statement>
    
             This expands statement if string is null (blank).
    
    b.   I%NB <string> <statement>  <else-statement>
    
             Expands statement if string is nonnull (nonblank).
    
    c.   I%IDN <string1> <string2> <statement>  <else-statement>
    
             Expands statement if both strings are identical.
             (case is not significant). 
    
    d.   I%DF  <string1> <string2> <statement>  <else-statement>
    
             Expands statement if strings are different. 
             (case is not significant). 
    
    e.   I%GT <value1> <value2> <statement> <else-statement>
    
             Compares value1 to value2 and expands if greater than.
             The  values  must  be decimal numbers with an optional
             minus sign. Usually they reference some parameter that
             expands into a number.  This  is  also  the  way  that
             numerical variables are compared. 
    
             For example:
    



                                      -6-                                2.4



    Vax Mp                      August 22, 1981                       Vax Mp


                    i%gt #@#a 50 <expand if a gt 50> <if not>
    
             see below for explanation of #@#a.
    
    f.   I%LT <value1> <value2> <statement> <else-statement>
    
             Compares value1 to value2 and expands if less than.
    
    g.   I%IN <key> <S1,S2,...,Sn> <E1,E2,...,En> <else>
    
             Compares key to each of Sn until  a  match  is  found,
             then  En  is  expanded. If no match is found, then the
             else statement is expanded. Else may be omitted.  Null
             strings  may  be present where desirable. (case is not
             significant). 
    
    
    h.   I%SW switch# <statement1> <else-statement>
    
             Expands statement1 or the else statement depending  on
             whether  the  switch is set. See below for explanation
             of switches. 
    
    
    i.   I%R <arg> <statement1> <else-statement>
    
             This statement tests arg for spaces, tabs, commas,  or
             square brackets and expands statement1 if any occur or
             the else-statement otherwise. Either may be null. This
             essentially  determines  if  the  arg is a `recursive'
             expression. 
    
             Example:
    
                    i%r <a[b]> <this, it is recursive> <not this>
                    i%r <a-b.> <not this, it's not recursive> <but this>
    
    j.   I%EXP <arg> <statement1> <else-statement>
    
             This  tests arg to see if it is an expression. It is a
             specific  test  for  the  default  macro  library.  An
             expression  is  anything  that  has multiple arguments
             where the second argument is one of the  4  arithmetic
             operators. 
    
             Example:
    
    
             I%EXP <a + b> <does this since there's a +> <not this>
             I%EXP <a[b]>  <not this> <but this, no expression>
    
    
    k.  %if type parm1,parm2...



                                      -7-                                2.4



    Vax Mp                      August 22, 1981                       Vax Mp


        %else
        %fi
    
             These three statements implement a block if conditional.
             The  %if  accepts  a  type  (from  the  single  line  if
             statements, less the i%) and any parameters depending  on
             the type. For example: 
    
                %if idn <#@1> <#@2>        %if in <#@1> <a,b,c,d>
                   ...                        ...
                %else                      %fi
                   ...
                %fi
    
                  (The #@n notation is explained in section 2.7).
    
             These  may  be nested to any level, but must be the only
             conditional on a line. 
    
    2.5 More internal statements
    
    The following internal statements are also available.
    
    a.   I%DOUT <statement>
    
             This will output statement  directly  without  further
             recursive  expansion.  This is useful when one desires
             to supplement code to  an  existing  target  assembler
             directive.  One  example  might be to output something
             additional to the .END statement by defining  a  macro
             called  ".END"  and having it output some code and end
             up with  an  output  of  the  actual  .END  directive.
             Comments may be output in this fashion as well. 
    
             Note that an equivalent form is:
    
                    ~ statement
    
             where the `~' must be in column 1.
    
    b.   I%ERR <message>
    
             This  outputs  a .error statement to the ti: device as
             well as to the file. The formats are:
    
                 .error ;message           to the file
                 line n message            to the terminal
    
    
    c.   S%SW switch#
    
             This sets the switch specified. The switch  is  turned
             on  if  switch# is positive and off if preceded with a



                                      -8-                                2.5



    Vax Mp                      August 22, 1981                       Vax Mp


             minus sign. 
    
    
    d.   E%S <symbol> n {m}
    
             Enters symbol into a symbol  table  with  the  integer
             values of n and m (optionally) associated with it. The
             symbol may be subsequently looked up, see below. 
    
                   Example:
                            e%s abc 5
                            e%s def 5 4
             Places abc in symbol table with value  5. (The  symbol
             table  size  is a parameter that may be adjusted at mp
             build time. See stak.mac).
    
    
    e.   T%YP symbol number {number2}
    
             This directive places the type value (an integer) into
             the number register specified or zero if the symbol is
             not present. 
    
                   Example:
                            t%yp abc 1
                            t%yp def 1 2
             Places  the value of symbol abc (5 from above example)
             into variable v1. Def has two numbers  which  go  into
             variables v1 and v2. 
    
    f.   D%SYM
    
             This  directive  dumps the symbol table as a series of
             macro calls. The format is as follows: 
    
                                 $$$$$$4 n
                                 $$$$$$5 sym val
                                 $$$$$$6 n
    
             where  n  is  the  number of symbols and the $$$$$5 is
             expanded once for each symbol in the symbol table. The
             definitions for these are as debugging aids. They dump
             the  symbol  table   to   the   terminal   when   used
             interactively. 
    
    
    g.   S%N num0 = num1 op num2
    
             Sets  the  value  of numeric variable num0 to num1 and
             optionally operates on it with num2.  The  valid  op's
             are: 
    
                            +  add



                                      -9-                                2.5



    Vax Mp                      August 22, 1981                       Vax Mp


                            -  subtract
                            *  multiply
                            /  divide
                            &  logical and
                            !  logical or
                            L  lesser of the two
                            G  greater of the two
    
             Num1 and num2 are either signed  decimal  numbers  (16
             bits  worth) or v# to denote variables. There are only
             30 directly accessible numbers: 0..30. However,  using
             indirect  notation, 31-49 are accessible. This is done
             using @n notation (e.g. @9 means  indirect  thru  v9).
             Note that va's address is 10, vb's is 11, etc. 
    
             See also  the section on macro operands.
    
             Examples:
    
             S%N v0 = 6 + 7          ;sets numeric variable 0 to 13
             S%N v0 = v6 * 7         ;sets v0 to v6's value * 7
             S%N v0 = 5              ;sets v0 to value 5
             S%N v6 = @5             ;sets v6 to value in variable
                                     ;pointed to by v5.
             S%N  @5 = 6             ;puts 6 into location v5 points
                                     ;to (indirect thru v5)
             s%n  v2 = 7 L 6         ;v2 gets the 6 (less than the 7)
             s%n  vt = @a G vq       ;vt gets the greater of the number
                                     ;pointed to by va and the contents
                                     ;of vq
             s%n  vt = vz - 1        ;vt gets the number of arguments less 1.
    
    h.   S%len   <string>  num
    
             This computes the length  of  <string>  in  characters
             (may  be  zero)  and  puts  the  value  into numerical
             variable num. 
                    E.g.
                            s%len <abc> 4    ;v4 gets a 3
                            s%len <abc> 10   ;va gets a 3
    
    i.   S%pos   <string>  <substring> num
    
             This  locates  the position of the substring in string
             and puts the value into numerical variable num. If the
             substring is not found, then zero  is  placed  in  the
             variable. 
                    E.g.
                            s%pos <abc> <ab> 4  ;v4 gets a 1
                            s%pos <abc> <bc> 10 ;va gets a 2
    
             The  matching  is  case  insensitive.  If  any  of the
             substring character is a control-b (ascii 2)  it  acts



                                      -10-                               2.5



    Vax Mp                      August 22, 1981                       Vax Mp


             as a single character wildcard matching anything. This
             character  is of course non printing and should not be
             used without good reason. 
    
    j.   **  macro  parm1 parm2 ...
    
             This opcode expands `macro' once  for  each  non-blank
             parameters.  Note  that `macro' may be null to execute
             multiple commands on a single line. 
    
             Example:
    
                  ** <>  s1,s2,s3    ;executes s1,s2,s3 in sequence
                  ** <abc def >  p1,p2,p3   ;executes:
                                                      abc def <p1>
                                                      abc def <p2>
                                                      abc def <p3>
                                            ;in sequence
    
             Note  that `macro' can be any string; not only a macro
             name. Each parameter is concatonated  to  `macro'  and
             then expanded. When `macro' is null, a pair of <>'s is
             NOT placed around Sn.
    
    k.   %rept
         %endr
         %lexit
    
             The  most recent addition is a repeat block mechanism.
             It is not totally implemented however. The  %rept  and
             %endr  form  an  infinite loop (only within a macro!!)
             that must be broken via the %lexit (or a  %exit).  The
             problem  is that the %lexit does not take affect until
             the %endr is reached (if it exited  immediately,  then
             the  %if  level  would  get  lost). However, the %exit
             causes immediate exit of a macro (this  works  because
             macro  exit restores the %if level properly). In order
             to use properly, the %lexit should either  be  at  the
             end of the repeat block or used as follows: 
    
                    %rept
                       ....                         ;stuff at top
                       %if ....                     ;test for exit
                          %lexit                    ;either exit
                       %else
                          ...                       ;or do rest of
                       %fi                          ;the loop
                    %endr
    
    l.   I%DIN  <statement>
    
             This  takes  statement  and  simulates  an  input from
             source  level.  This  means  it  will  check  for   an



                                      -11-                               2.5



    Vax Mp                      August 22, 1981                       Vax Mp


             assignment   statement   etc.  The  reason  assignment
             statements are only checked at  source  level  is  for
             speed. 
    
    
    m.  %exit
    
             This causes an immediate exit of the current macro.
    
    
    n.  !mcr command
    
             This  is  primarily intended for interactive debugging
             of macro libraries.  It  permits  a  temporary  escape
             (like  in  the  editor)  to the operating system. NOTE
             that on  the  VAX  version  2.2  or  less  (at  least)
             spawning  from  a  compatibility mode process does not
             work and causes a fatal error such  that  the  process
             must be aborted.  The `!' must be in column 1.
    
    
    2.6  Switches
    
         Mp reads the command line and extracts switches without  using
         the  CSI  modules.  Thus  switches  can appear anywhere on the
         line. They are always  2  letters  and  have  no  negation  or
         optional  data  capabilities.  Each switch is assigned a number
         (from 1 to 33) and it is this number which may  be  referenced
         in  the I%SW and S%SW statements described above. There are 16
         switches which are reserved for Mp and the rest can be used by
         the user. The switches are: 
    
    
    1.   /nl
    
             No  .print statements generated. This is now the default
             since .print statements in macro-32 are  different  that
             in macro-11. 
    
    2.   /da
    
             Not implemented.
    
    3.   /is
    
             This will print on ti: internal macros as they are read.
             This  aids  in  locating  a  faulty macro that bombs the
             preprocessor. 
    
    4.   /me
    
             Expands  macros  one  level  deep  only  (for  debugging
             macros). 



                                      -12-                               2.6



    Vax Mp                      August 22, 1981                       Vax Mp


    
    5.   /ml
    
             Use local directory for standard macro  library  name,
             not [1,1].
    
    6.   /op
    
             Not implemented.
    
    7.   /tr
    
             Implements the trace feature. 
    
             This causes Mp to internally invoke two macro calls  for
             every  statement  input.  The two macro calls are passed
             the entire input line as  parameters.  One  call  occurs
             before expansion of the statement and one after. 
    
             Example:
                    input line:   LET a = b
    
                    affect:       $$$$$$1 LET a = b
                                  (expansion of LET a = b)
                                  $$$$$$2 LET a = b
    
             The two macros $$$$$$1 and $$$$$$2 must be user defined.
    
    8.   /ni
    
             No internal macro definitions. 
    
    9.   /md
    
             Expands   macros   and   outputs   (as  a  comment)  all
             intermediate steps during expansion of the macro. 
    
    10.  /pp
    
             Not implemented. 
    
    11.  /un
    
             Outputs to the ti: device, amounts of storage used after
             macro libraries are read  in  (to  determine  how  large
             table sizes should be in the task image - see stak.mac).
    
    12.  /x2
    
             Turns  on unary operator recognition for first operator.
             It is not recommended that this switch be  applied  until
             all  macros  are  read  in,  or  any  detection  of  the
             operators during macro load time  will  cause  expansion



                                      -13-                               2.6



    Vax Mp                      August 22, 1981                       Vax Mp


             which  is  not  usually desirable. Rather they should be
             turned on by program control as needed. See see  section
             on Macros for further information. 
    
    13.  /x3
    
             Turns on unary operator recognition for second operator. 
    
    14.  /x4
    
             Turns on unary operator recognition for third operator. 
    
    15.  /x5
    
             Turns on unary operator recognition for quote operator.
    
    31.  /lm
    
             Used  to  signal  that  local macros are included in the
             source file. 
    
    32.  /na
    
             This directs the  statement  processor  to  not  attempt
             further  statement  parsing when the opcode field has an
             unknown symbol. 
    33.  /nb
    
             This  suppresses the output of the stack usage unless it
             gets below a critically low value. 
    
    34.  /mc
    
             This  dumps macro call entrys and exits as comments.
    





















                                      -14-                               2.6



    Vax Mp                      August 22, 1981                       Vax Mp


             The  remaining  switches  are  unassigned  and  are   as
             follows: 
    
    
                    switch 16 as /x6       <----|
                    switch 17 as /x7            |
                    switch 18 as /x8            |---{ used by default
                    switch 19 as /x9            |     macros.
                    switch 20 as /x0            |
                    switch 21 as /y1       <----|
                    switch 22 as /y2
                    switch 23 as /y3
                    switch 24 as /y4
                    switch 25 as /y5
                    switch 26 as /y6
                    switch 27 as /y7
                    switch 28 as /y8
                    switch 29 as /y9       <----- used by default macros
                    switch 30 as /y0
    
    
    
    2.7  Macro definitions and arguments
    
         Macros have the form:
    
                           $MACRO name
    
                            macro text
    
                           $ENDM
    
    Additional information on the $MACRO and $ENDM lines is optional and is
    treated as comments.
    
    Arguments  are referenced as #@n where n is 0..9,A..K (upper case). For
    example, the following is a definition of a push macro. 
    
                            $MACRO push
                             mov #@1,-(sp)
                            $ENDM
    
    This macro would be called (for example):
    
                            push this
    
    And it would generate the following code:
    
                            mov this,-(sp)
    
    
    One additional syntax item (not found in macro-32) is the following: An
    argument of the form A[B] is treated as <A,B>.



                                      -15-                               2.7



    Vax Mp                      August 22, 1981                       Vax Mp


    
    Macro  arguments  are substituted into macro text as follows: A left to
    right scan is performed copying text into a secondary buffer  character
    for  character  until  an  argument reference occurs. Then the argument
    text from the command line is copied replacing the argument  reference.
    When  copying  the  argument text itself, no interpretation of argument
    references is made and no  second  pass  on  the  line  is  made.  Thus
    recursion within macro argument replacement is disallowed. 
    
    
    
    2.8  The string stack
    
    
    Mp has a string stack  which  is  communicated  with  using  5  special
    directives  discussed below. These directives may be used anywhere in a
    program either directly or inside a macro. However, when used outside a
    macro there are no parameters to receive the values from this stack and
    thus the results are discarded. 
    
    The stack appears to be a 60 element string array.  The  first  24  are
    generally  used  for  stack  1,  25-30 as a scratch area, and 31-60 for
    stack 2. Item 29 contains the string used to generate labels. There are
    2 forms of this construct as follows: 
    
    
      1.                        ??  p1,p2,...,pn
    
         This format does not  reference  the  string  stack  directly  but
         generates  automatic  symbols  of  the form $$$nnn and places them
         into the list of parameters specified. Example:
    
                                   ?? 1,2
    
         would generate (assuming no other labels have yet been gen'd)  two
         symbols
    
                       $$$1 which would replace argument 1
    
                       $$$2 which would replace argument 2
    
         If the arguments  had  been  defined  (i.e.  not  null)  then  the
         previous  contents are lost.  The `$$$' is the default and by user
         control can be changed to some  other  string.  See  the  absolute
         string placement below.
    
    
    








                                      -16-                               2.8



    Vax Mp                      August 22, 1981                       Vax Mp


    
      2.                 ?- <string> relative absolute switch
    
                                       and
    
                         ?+ argument relative absolute switch
    
         The  above  are  pushes  (-) and pops (+) of the string stack. The
         `?-' expects a literal string to be supplied as <string>. This  is
         usually done via some reference to an argument. 
    
         Example:
    
                                   ?- #@1
    
         This will push argument 1 onto the stack.
    
         The second parameter (if supplied) specifies a  position  relative
         to  the  stack  pointer and ALSO denotes that the operation is NOT
         actually a push, rather it is a move.
    
         Stack relative placement does not modify the stack pointer.
    
         Example:
    
                                  ?- #@1,2
    
         This will place argument 1 into the stack at position 2.  The  top
         grows downward and begins at location 1 of the string stack.
    
         The  third  parameter  (if  not  null)  specifies  that  the  push
         (actually move) is not relative to anything but is absolute.
    
         Example:
    
                                 ?- abc,,29
    
         This will place the string `abc' into absolute position 29 of  the
         string   stack,   thereby  setting  the  label  generation  string
         described above.
    
    
    
         The fourth argument is to conditionalize the entire  operation  on
         the  status  of  a  particular  switch. This capability is not  as
         important as it was in previous versions of mp but it remains.
    
         Example:
    
                                 ?- #@5,,,20
    
         This specifies that if switch 20 is set then push argument 5  onto
         the stack.



                                      -17-                               2.8



    Vax Mp                      August 22, 1981                       Vax Mp


    
         To specify that the condition is based on the switch NOT being set
         then supply a negative switch number.
    
         The ?+ operation is analogous to the ?- operation with  respect  to
         the relative, absolute, and switch parameters. The first parameter
         is however the argument number in which to move to. This number is
         a decimal number.
    
         Example:
    
         Suppose we redefine the push  macro  such  that  if  the  argument
         supplied is reg0 then we will change it to R0.
    
         $MACRO push parm1
         ?- R0,,25                     ;put an R0 into string element 25
         I%IDN reg0,<#@1> <S%SW 26> <S%SW -26> ;set switch 26 if arg1 = `reg0'
         ?+ 1,,25,26                   ;if sw 26 set, move str 25 to arg1
         mov #@1,-(sp)                 ;now do the actual push
         $ENDM
    
         The above example demonstrates some of  the  stack  options  in  a
         macro  but  is  not  very  efficient  in  terms of statements (the
         overriding concern for speed). The following shows how  to  do  the
         same  thing  in one statement.
    
    
            $MACRO push
            I%IDN <#@1> reg0 <mov r0,-(sp)>  <mov #@1,-(sp)>
            $ENDM
    
         The second stack pointer is referenced as ++ or --.
    
         Example:
    
                 ?-- abc         ;pushes "abc" onto stack 2.
                 ?++ 3,2         ;pops next to top of stack 2 into parm 3
    
         Macros may also be expanded by the use of certain unary operators.
         When the scanner   encounters a token (each parameter of  a  macro
         and  the opcode itself) it checks to see if the first character is
         one of 3 operators (defined in the tkb file for mp). If it is  and
         switches  12,  13, or 14 respectively for operators 1, 2, and 3 is
         also set, then an expansion of the macro $x is performed (x is the
         unary operator). The token is stripped of the operator and  passed
         onto  the $x macro as parameters. The $x macro is user defined. It
         may generate code or just fiddle with the stack and switches  etc.
         On  exit  however, it MUST push onto stack one a string which will
         replace the token which caused the expansion. 







                                      -18-                               2.8



    Vax Mp                      August 22, 1981                       Vax Mp


    
         Example:
    
                           LET a = _function[a,b]
    
         where  `_'  is  the  unary  operator  would  cause  the  following
         expansion to be invoked (before the LET is invoked): 
    
                           $_ function,a,b
    
         IF $_ returns (via a push on stack one) the  string  `replacement'
         then the let statement would be expanded as: 
    
                            LET a = replacement
    
         A suitable macro definition for `$_' could be: 
    
                            $MACRO $_
                            ?- replacement
                            $ENDM
    
    
    
    
    
    
    
         The  quote character (usually " but definable at mp build time) is
         a special case  unary  operator.  Its  interpretation  depends  on
         switch 15. If switch 15 is off, then a quoted string is treated as
         a macro argument in <>'s. For example: 
    
                            "Quoted string"
    
         is the same as:
    
                            <Quoted string>
    
         However,  if  switch  15 is on, then it is also treated as a unary
         operator but the entire argument is passed to the $" macro in  one
         piece. 
    
         For example:
    
                            LET a = "Quoted string"
    
         would cause "Quoted string" to be passed to $" as: 
    
                            $" <Quoted string>
    
         This  allows an implementation of the $" macro to output a labeled
         ascii statement (possibly in  a  data  psect)  and  replacing  the
         "Quoted  string"  (in  the  LET statement) with the address of the



                                      -19-                               2.8



    Vax Mp                      August 22, 1981                       Vax Mp


         ascii string. This is basically what the default  macros  do.  See
         the file mcmd.mac. 
    
         Note that all the numbers specified in ?-, ?+, etc. statements can
         be macro parameters or numerical variables  as  discussed  in  the
         next section. 
    
    
    
    2.9   Macro argument operators
    
     Macro arguments may be either simple argument references or  they  may
     select  portions  of the argument. An argument reference which has the
     following format selects a portion of the argument selected. 
    
                    #@=n(f:l)
    
     In  this format `n' is the argument number, `f' is the first character
     in the argument and `l' is the last. The `n', `f', and `l'  parameters
     are  all  single digits 0..9,A..U or vx where x also can be 0..9,A..U.
     Anything not a number or letter (or `Z') (or larger than the  argument
     for the `l' parameter) is converted to the number of characters in the
     argument.  When the format is vx this means use the value contained in
     numerical variable x. 
    
     For example:
    
    
                    #@=1(2:Z)       ;extracts chars 2-end of arg 1
                    #@=A(B:D)       ;extracts chars 11-13 of arg 10
                    #@=v3(v5:v6)    ;v3 specifies which argument, v5
                                    ;specifies 1st character position
                                    ;to extract, and v6 the last.
    
     To reference multiple arguments the following form is used:
    
                    #@*(f:l)
    
     which  concatonates arguments `f' thru `l'. The same rules for f and l
     as above apply here as well except a value larger than the  number  of
     arguments  is  converted  to  the  number  of arguments (not including
     locally defined labels). 
    
     For example:
    
                    #@*(2:Z)                ;selects args 2 thru n-args
                    #@*(3:B)                ;selects args 3 thru 12
                    #@*(v1:Z)               ;v1 thru last argument selected
    
     The `:' is actually a special case for the `separator' character which
     is output between each character  (in  extraction  of  characters)  or
     argument  (multiple argument selection). The following table describes
     the `separator' characters currently in use. 



                                      -20-                               2.9



    Vax Mp                      August 22, 1981                       Vax Mp


    
    
      -------------------------------------------------------------------
      |     "       double quote            separates with ><            |
      |     :       colon                   no separation (null)         |
      |     _       underline character     separates with a space       |
      |     x       any other char          separates with x             |
      --------------------------------------------------------------------
    
    For example, the macro call:    TEST arg1 arg2 arg3
    
    
    The following argument references:
    
    
    
            #@=1(1,Z)       --->    a,r,g,1
            #@=1(1:Z)               arg1
            #@=1(1"Z)               a><r><g><1
            <#@=1(1"Z)>             <a><r><g><1>
    
    
            #@*(1,Z)                arg1,arg2,arg3
            #@*(1_Z)                arg1 arg2 arg3
            <#@*(1"2)>              <arg1><arg2>
    
     Note  that  arguments separated by <><> type pairs do not need a comma
     or space  between  them.  The  ><  characters  are  the  corresponding
     characters  defined in the Mp task build file for left and right angle
     brackets. If these values are  changed,  the  characters  used  as  ><
     separators in the argument selector also are changed. 
    
     A  special  case argument reference exists which permits conditionally
     appending (ap) or (fp) to  the  argument  (the  strings  appended  are
     defined in stak.mac). An argument reference of the form: 
    
                            #@{n}
    
     where n is of the form used above  to  reference  an  argument  number,
     causes  the  symbol  table  to  be  searched  for the string defined by
     argument n. Depending on  the  symbol  type  (auto  or  parameter)  the
     corresponding  register  is used in displacement mode. Additionally, if
     the symbol is of type register (10 thru 22), then it is  replaced  with
     the  corresponding  register Rx (computed via type-10). When the symbol
     table is searched, any leading `@'  is  ignored.  Thus,  @sym  will  be
     correctly  replaced  by @sym(ap), @sym(fp), or (Rx). This capability is
     heavily used by the default macros supplied with this processor. 
    
     This construct (#@{n}) also checks for an argument that  contains  only
     digits  (0..9) and an optional minus sign (-) which it then converts to
     #^D<x> to make it a decimal integer and to #^Ox if it is preceded by  a
     0.  Thus 9 becomes #^D<9> and 07 becomes #^O07. The <> are necessary to
     allow for negative numbers (#^D-1 must  be  #^D<-1>).  Lastly,  if  the



                                      -21-                               2.9



    Vax Mp                      August 22, 1981                       Vax Mp


     argument  begins  with either ` or ' then it is mapped into #^a'...' or
     #^a`...`. The argument must be terminated by ` or ' as well. Thus `abc'
     is mapped into #^a`abc`.
    
     The 30 numerical variables discussed in the S%N internal statement can
     also be referenced inside a macro with a similar syntax. Any  argument
     of the form: 
    
                                    #@#x     or
                                    #@#@x
    
     Is  replaced  by  the  number  x  or  the number x points at (indirect
     through x). Recall that x may by 0..9,a..u.  Actually,  any  level  of
     indirection  may be specified with multiple @'s (e.g. #@#@@9 is double
     indirect). Be warned that  #@#vt  is  not  what  you  think  and  that
     variables v, w, x, y, z are reserved. 
    
                    Example:
    
                            $MACRO test
                            mov #@#t(fp),-(sp)
                            $ENDM
    
    
     In the above, it is assumed that vt contains an offset  into  register
     fp.  If  it  had  contained  the value 10 (decimal) then the following
     would have been output: 
    
                            mov 10(fp),-(sp)
    
     This is a useful mechanism for generating temporaries. 
    
























                                      -22-                               2.9



    Vax Mp                      August 22, 1981                       Vax Mp


    3.  Operating instructions
    
         Mp uses the get-command-line routine with 1 level of  indirection.
         It does not make direct use of the CSI parsing routines; rather it
         parses the command line itself. The format is:
    
         mp>OUT=IN[+MACROLIB][/sw's]
    
                 or
    
         mp>file[+macrolib][/sw's]
    
         IN is the input file (def ext=.mac)
         OUT is the output file (def ext = .mpp)
         MACROLIB is an optional library of MP macros (def ext = .mac)
    
         For example: To compile the file SOURCE.mac into SOURCE.obj:
    
                    mp source           ;same as mp source.mpp=source.mac
                    macro  source.mpp   ;macro-32 call
    
    
         If there is  no  `='  present,   then  "file"  is  converted  into
         "file=file".  In  this case the extensions must be defaulted.  The
         choice of .mpp for the intermediate file  extension  is  to  allow
         easy deletion of temporary files.
    
         If no command line is entered, repetitive mode is enabled. In this
         mode a file is translated until an eof on input. Then command mode
         is re-entered (like pip or tkb etc.). Thus  multiple  translations
         are permitted (usually from an indirect file). However, macros are
         only defined for the first command entered.  This allows a set  of
         modules to be translated with out the reloading of macro libraries
         (and the internal macro definitions). If new  macros  need  to  be
         defined the processor must be reloaded via a new invocation.
    
         One useful technique for debugging macros is the following:
    
             mcr>mp
                 mp>ti:+lib/sw's          -input and output to tty
                     interactively test macros
                     control-z
                 mp>ti:/sw's
                     more interactive tests with different switch settings
                     control-z
                 mp>control-z             -to exit mp.
    
         This  technique allows one to test a macro and switch on the macro
         expansion if a problem results. It is also a good way to see how a
         macro expands before actually writing code that uses a  particular
         construct. One may also turn on/off switch 9 interactively to turn
         dumping on and off.
    



                                      -23-                               3.0



    Vax Mp                      August 22, 1981                       Vax Mp


    
         Internal error reporting is poor in the expander. If messages come
         out out on  the  terminal  that  say  things  like  string  buffer
         overflow  or  string  index  out  of range, you have exceeded some
         internal limit. Check the last thing you wrote. Usually the  error
         is  caused by some butchered statement or one with unterminated <>
         pairs. The expander will write the offending line on the terminal.
         In some cases, a .error statement is generated. 
    
    
         Some times it may be necessary to rebuild the task with  a  larger
         stack and if many local symbols are generated there is a parameter
         which can be increased in the tkb file.  Stak.mac  also  has  some
         values which can be increased if you run out of space for macros.
    









































                                      -24-                               3.0



    Vax Mp                      August 22, 1981                       Vax Mp


    4.  Built in macros
    
         The   following   is   a  description  of  a  language  translator
         constructed using Mp. It is supplied with Mp as the default  macro
         library,  that  is,  the one built into the Mp task. The library's
         control structures were  loosely  copied  from  the  C  and  Basic
         languages.  For  reasons  of  efficiency,  some  macros  have been
         incorporated into the  macro  processor.  The  document  hards.doc
         describes  the  various  internal  routines  that  implement macro
         expansions. 
    
         In the following description:
    
                 repeat*            repeated 0 or more times
                 repeat+            repeated 1 or more times
                 thing              a syntactic item (non-terminal)
                 OTHER STUFF        literal string if upper case
                 {   }              optional 0 or 1 time
                 {   }*             grouping repeated 0 or more
                 {   }+             grouping repeated 1 or more
    
    
    4.1     Language description
    
        The language is compatible with the standard vax calling sequence.
        It  always  generates  a  stack  call  (calls)  but  references to
        arguments are through the ap so the caller can be fortran or other
        languages. The  code  that  is  generated  is  generally  position
        independent,  but  use  of  absolute  symbol  references  must  be
        monitored  by  the  user  to  create  truly  position  independant
        routines. 
    
        In most cases the normal assembler modes can be  used  wherever  a
        variable  is permitted, but those with side affects (auto increment
        etc.) usually will not work. However, the expander does not  check
        for  this situation. The []'s are reserved for use by the language
        and thus indexed mode cannot be directly used. There  is  however,
        the escape mechanisms of ~ in column 1 and the i%dout statement. 
    
        The language requires the user to supply lexical information, that
        is,  all  tokens must be separated by spaces or commas.
    
        Symbols  used  inside  functions may be reused in other functions.
        However, undeclared variables in one function which are  declared
        in  another  function  will  cause  undetectable (at compile time)
        errors. Variable names may be declared to be  register  variables,
        which  will  map  to  registers  r11  down,  and the expander will
        allocate temporary registers from rx on up where the user can  set
        the first register (see the program statement). Any registers below
        rx  can  be  used  freely  by  the  user,  but  r0  and r1 must be
        referenced only in limited ways (see below). Functions always save
        all registers (r2 to r11) on entry. 
    



                                      -26-                               4.1



    Vax Mp                      August 22, 1981                       Vax Mp


        If the optimizer is to be used, the user must not  use  r0  or  r1
        except  in  limited  ways  as  described  in  section 4.9. This is
        because the code generation uses r0 and r1 for  specific  purposes
        and  thus  enables  the  optimizer  to operate on a window of code
        without the need  to  be  very  smart.  Since  the  optimizer  can
        generally  be  expected  to  reduce  the total size of a module by
        10-20 percent, it is  well  worth  the  penalty  of  minor  coding
        restrictions. 
    
    
    
    4.2     Program structure.
    
    
    
       |------------------------------------------------------------|
       |                                                            |
       |               Required program structure                   |
       |                                                            |
       |                                                            |
       |------------------------------------------------------------|
       |       program Name            |used once                   |
       |                               |                            |
       |       .long ...               |------------                |
       |       .ascii ...              | static and/or              |
       |       .byte...                | global data                |
       |                               |------------                |
       |FUNCTION entry[p1,p2 ...]      |                            |
       |       auto l1 l2 l3 ...       | Function 1                 |
       |       register  x1 x2 x3 ...  |                            |
       |       external  y1 y2 y3 ...  |                            |
       |       {                       |                            |
       |       ...                     | code is here               |
       |       return  value           |                            |
       |       }                       |                            |
       |                               |-------------               |
       |FUNCTION entry2[p1,p2 ...]     |                            |
       |       auto l1 l2 l3 ...       |                            |
       |       register  x1 x2 x3 ...  | Function 2                 |
       |       {                       |                            |
       |       ...                     | code is here               |
       |       return   value          |                            |
       |       }                       |                            |
       |                               |-------------               |
       |                                                            |
       |------------------------------------------------------------|
    
    4.3  Data types
    
         The  language  supports only longwords, words, and bytes. There is
         no concept of integer,  real,  etc.  Just  bit  streams.  Data  is
         usually  accessed by longword but may also be referenced as arrays
         and structures. Even if a variable is allocated as a  longword  it



                                      -27-                               4.3



    Vax Mp                      August 22, 1981                       Vax Mp


         can  still be treated as an array of 4 bytes.   However, no bounds
         checking is done. 
    
              The data can, however, be in 4 modes. These are: 
    
                    Hardware register
                    Function parameter
                    Local stack allocated data
                    Static local or external data.
    
         The  translator  will  determine from a symbol table which mode is
         required of a variable and perform different transformations.  For
         example,  a  variable  in  a register must be mapped to the actual
         register name  rx  and a function parameter must be changed  to  a
         displacement  value  off  of  the  hardware ap register. Likewise,
         local data is a displacement to  the  frame  pointer  (fp).  These
         transformations  occur  automatically, even if vax machine opcodes
         are specified to operate on  these  mp  variables.  Some  special
         operations  can  be  performed  on  some  of  these types. This is
         described below.
    
         a.   The & operator
    
              This  permits  the  computation  of the address of a local or
              parameter variable  in  assignment  statements  and  function
              parameters. 
    
              For example, if b is a local 
    
                                  a := &b
    
              This will generate code which puts the address of b into a. 
    
                           a := function.of[c,d,&e]
    
              This invokes `function.of' passing c, d, and the  address  of
              e. The function returns a value in r0 which is stored in a. 
    
         b.   The @ operator
    
              This permits the  indirection  thru  a  register,  local,  or
              parameter variable. (@a[b] etc. is not allowed).
    
              For example
    
                                  a := @b
    
         c.   Array references
    
                            array[index{,l/w/b}]
    
              where  the default is l (long word). For example a byte array
              reference would look like: 



                                      -28-                               4.3



    Vax Mp                      August 22, 1981                       Vax Mp


    
    
                            array[index,b]
    
              And a long word reference as: 
    
                            array[index]
    
                                or
    
                            array[index,l]
    
              If  array  is  a parameter variable, then the contents of the
              array   parameter are used as a pointer  to  an  array.  Auto
              variables are accessed directly. 
    
              There  is  an  implied  conversion  of signed byte to long or
              signed word to long,  so  that  mixed  mode  expressions  are
              permitted. 
    
              Since array notation is similar to a function call, any array
              variable used must be declared. The default interpretation is
              the function, but external functions should be declared. 
    
              Auto  variables  may  be  declared  as pointer variables with
              respect to how they are  treated   by   the  array  operator.
              Normally an auto array is declared with a specified value (in
              units  of  bytes, words or longwords ) which causes the stack
              to be decremented on function  entry  (by  the  corresponding
              amount).  Alternatively  one  can  declare  a single longword
              variable as *var which only  is  meaningful  with  the  array
              operator.  In  that  event,  the  auto variable is treated as
              though it were a single parameter variable which contains the
              address of an  array.  When  a  variable  declared  to  be  a
              register  is  used  in  an  array  reference,  the same thing
              happens, i.e. the register's contents are used as the address
              of the actual data. 
    
                    Example:
    
                    function test[x,y]
                            Auto a,*b,c
                            {
                               b     := x + y
                               b[a]  := c
                            }
    
              This  would  cause  the  contents  of  x  plus  y to be added
              producing a value which is the address of  the  beginning  of
              some  array.  Then, b[a] would reference the a'th longword in
              that array. Note that if b were declared a register then  the
              same  effect  would  result,  but  different  code  would  be
              generated - hopefully shorter. 



                                      -29-                               4.3



    Vax Mp                      August 22, 1981                       Vax Mp


    
              The arguments of an array or function can be either a term or
              an expression in <>'s. It is invalid to enclose a single term
              (or  a  function  call or array reference) in <>. I.e. the <>
              pair is used to signify an expression. 
    
         d.   Member references
    
                           #member[pointer]
    
                                  or
    
                          #member[pointer,l/w/b]
    
              This notation is an extended displacement mode, that  is,  it
              takes  the  member name as an offset (this may be a constant)
              and adds it to the pointer value (which may be an  expression
              etc.) and uses that address to access a long, word, or byte. 
    
              Example:
    
                    a := #left_link[pointer]
                    x := #right_link[#left_link[node]]
                    byte := #access_code[system_structure,b]
    
    4.4    Constants
    
          a.  Strings
    
              A string is defined to be: 
    
                 "any string of ascii characters not including d-quote"
    
              The string is passed onto macro as: 
    
                           .asciz _ascii string_
    
              one  can  imbed non-printing characters (or " or _ itself) as
              follows: 
    
                           _<###>_ is a single character.
    
    
              Example:
    
                            "This string contains a line-feed here _<12>_"
    
    
              Since all library routines expect strings  to  be  passed  by
              descriptor, the string notation of 
    
                           "__string text"
    



                                      -30-                               4.4



    Vax Mp                      August 22, 1981                       Vax Mp


              will be converted to 
    
                           .ascid _string text_
    
              There is limitted suport for string literals of the form:
    
                           'a' , 'aa', 'aaa',  or 'aaaa'
    
              These are mapped into #^A'...'. Two characters  are  actually
              allowed  the  ` and '. Whichever starts the string is used to
              generate  the  output  format.  The  last  character  is  not
              actually  examined  (though  it must be present) and could be
              anything. For example, the following are valid: 
    
                           `a', 'a', `a`
    
              The limitation is that the characters  permitted  inside  the
              quotes may not be space, tab, comma, or left square bracket. 
    
           b. Numbers
    
              Numerical constants have the following format: 
    
                    a. #xxx                xxx = any assembler expression
                    b. {-}{digit}+         like 52 or -8090 or 0
                    c. 0{digit}+           like 0377 or 0177777
    
    
              The #xxx form is also used to get  the  address  of  external
              data  or  for  the value of global constants. If the #^A/.../
              form is used, then there may be no spaces, commas,  tabs,  or
              left square brackets. 
    
    
    4.5  Declarative statements
    
    
    o    PROGRAM {string} {rx}  {options}
    
              This statement must be the first statement in a program.
              It initializes the library and some labels  used  later.
              It  generates  a  .title  using string, uses string for
              label generation, and sets switch 15-21 to their initial
              values. If string is not entered then the  label  prefix
              must  be  setup  using SETLAB (see macros for more info)
              and no .title is output. 
    
              Rx is optional and specifies the first  register  to  use
              for temporaries. The default is r2.
    
              Options may be parameters 3 - n  and  currently  include
              the  value GLOBALS. This suppresses the .disable globals
              that is normally output to force definitions of external



                                      -31-                               4.5



    Vax Mp                      August 22, 1981                       Vax Mp


              symbols. Since much of the dec macros require the global
              default  for  undefined  symbols,  this  is  a  hook  to
              suppress  this safety measure. One could also simply add
              an .enable global statement inline after this statement. 
    
    
    o    FUNCTION name[parameter-label*]    {is local}
    
              This  is  the  first  statement  in  a  function. It can
              optionally declare that name  is  not  to  be  a  global
              variable. 
    
    o    AUTO  label+
    
    
              This  statement declares local stack frame variables. The
              default size is 4 bytes. To allocate a different  amount
              use the following format. 
    
                      AUTO var[amount{,type}] ...
    
              The  type  may  be byte, word, or long (the default) and
              only the first character is significant. 
    
              Autos  may  also  be  declared  as pointers. This has an
              affect only when used in an array context. The method of
              declaring is as: 
    
                      Auto *var
    
    o    REGISTER  var+
    
              Declares  variable  names to be equated to registers r11
              down. During output, the registers  actual  notation  is
              substituted. Only about 6 register variables are allowed
              and depends on the first temp register used. See Program
              above.  If  too many register variables are declared for
              the available registers, an error is generated  and  the
              user  must change some register variable declarations to
              Autos. 
    
    o    EXTERNAL  var+
    
              This  declares  variables   or   procedures   that   are
              statically  defined elsewhere in the program (or another
              file). The format for functions is: 
    
                            External func[*]
    
              Definition of all  symbols  and  external  functions  is
              suggested.  Note  that  a  conditional statement results
              which declares  the  parameters  external  if  they  are
              undefined. This assumes that variables declared external



                                      -32-                               4.5



    Vax Mp                      August 22, 1981                       Vax Mp


              (to  functions) might be defined above in the same file.
              If the user  were  to  define  the  external  after  the
              declaration,  then  the  assembler  would  do  different
              actions on pass 1 and  2,  with  unpredictable  results.
              This  would  of  course  be  an  improper  use  of  this
              preprocessor, but would  probably  not  be  detected  at
              compile or assembly time. 
    
    o    STRUCT name {initial_offset}
    o    MEMBER name+
    o    END-STRUCT {name}
    
    
              These  three  macros  provide  an  easy  way to generate
              offset values for some structure. It simply equates  the
              names  (labels)  to  absolute  values  (starting  at the
              initial offset which defaults to 0).  The  name  of  the
              structure  is just another label which is equated to the
              length of all the labels declared with the MEMBER macro. 
    
              Example:
    
                    STRUCT person
                      MEMBER name[20,bytes],address[30,bytes],zip[10,bytes]
                      MEMBER state[1,w],sex[1,w]
                      MEMBER occupation_code,birthdate[6,bytes]
                    END-STRUCT person
    
              The following label assignments  would  occur:  (all  in
              decimal) 
    
                      name=        0    (size =   20   bytes)
                      address=    20              30
                      zip=        50              10
                      state=      60               2
                      sex=        62               2
                      occupation= 64               4
                      birthdate=  68               6
    
                      and person would be 74 (length of all fields)
    
              These labels may be used as offsets to index  registers
              or  member references. The structure name may be used to
              allocate the necessary amount of storage  to  accomodate
              the structure. 
    
              Example:
    
                     bill     := alloc[#person]     ;storage allocater.
                     #sex[bill,w] := `m'            ;set field
                     addr_zip := bill + #zip        ;address of bill's zip
    
              Note that if bill were declared to be a register variable, and



                                      -33-                               4.5



    Vax Mp                      August 22, 1981                       Vax Mp


              the optimizer is used, then many statements reduce to a simple
              displacement mode reference.
    
    
    4.6   Executable statements
    
    
    o    RETURN  {Expr}
    
              Returns  from  a function with and optionally computes a
              value for r0. 
    
              For example, a complete (nonsense) program:
    
    
                 program sample
    
         function main[argc,argv]       ;function with 2 parameters
             auto i,a,b,j,k             ;local variables
             {
             do while a ne b
                 a := argc - 1
                 b := a - 1
                 loop for i := b downto 0
                     k := k + 1
                     loop for j := k  to  a    step two[k]
                        if strlen[argv[i]]  = strlen[argv[j]]
                             printf "(%s) = length of (%s)",argv[i],argv[j]
                        fi
                     next j
                 next i
             od
             return 1
            }
    
         function two[j]                   ;double routine
                 {
                 return  j * 2
                 }
                 .end
    
    
    
    












                                      -34-                               4.6



    Vax Mp                      August 22, 1981                       Vax Mp


    
    o Assignment statement.
    
    
             Assignment_statement ::= assignment  | function_call
             assignment           ::= dest := right
             right                ::= expr | term
             expr                 ::= term {operator term}+
             term                 ::= source | function_call | array | member
    
             source               ::= variable | constant | register | string
             dest                 ::= variable | register | array | member
    
             function_call        ::= function_name[arglist]
             arglist              ::= argument {,argument}*
             argument             ::= <expr> | term
    
             array                ::= variable_name[argument{,L|W|B}]
             member               ::= #element[argument{,L|W|B}]
    
             operator             ::= + | - | / | *
    
    
              Dest may not appear on the right  side  unless  its  the
              first  term  after  the  `:='. Only 6 terms are allowed.
              When referencing functions or  arrays,  r0  and  r1  are
              used. Expressions require the use of temporary registers
              which  are  allocated  automatically. Recursive function
              calls also require temporaries. Evaluation  is  strictly
              left  to  right.
    
              Examples:
    
                     a := b - c / d
                     a := b - fun[a,1,&c] * fun2[loc(r5),par(r5)]
                     s := "s gets address of this asciz string"
                     r := val[argv[1],10] + -5
                     r := func[array[<c - f[d]>]]
                     r := #member[array[<c - f[d]>]]
                     a := b
                     s := &b + @a
                     f[x]
    
              Two  intrinsic  functions  exist. They are: Ref and Bits. Ref
              takes a single argument (expression or term) and produces  as
              a   function  return  (in  r0)  the  address  of  a  longword
              containing the value of the expression or term.
    
                    Example:
    
                              fortran_routine[ref[a],ref[1]...]
    
    



                                      -35-                               4.6



    Vax Mp                      August 22, 1981                       Vax Mp


              Bits returns an extracted bit field as a  long  integer  into
              r0. Its format is as follows: 
    
                           bits[term,start_bit,number_bits]
    
              where  term is either a single variable or an expression, and
              start_bit and number_bits are simple variables, registers, or
              constants (no expressions or functions).  This  function   is
              also  a  special  case  function which can appear on the left
              side of an assignement statement. If term is a variable, then
              start_bit need not be 0-31 but can be an  index  into  a  bit
              array. 
    
    
              For example:
    
                            Auto a[4],b[4]
                               ...
                            loop for i := 0 to 127
                                bits[a,i,1] := bits[b,i,1]
                            next i
    
              This  example  will  copy a 128 bit array from b into a. Note
              the allocation of 4 longwords for  each  variable,  and  that
              auto variables can be referenced in the bit function. 
    
    
    o    IF(B) condition {OR|AND condition ...
    
                 or
    
    o    IF condition-code
    
    
    
        relation ::= NE | EQ | LT | HI | LO | LOS | HIS | GT | GE | LE | =
        condition-code ::= relation  | CC | CS  | ON  | OFF
    
        condition ::= value relation value
        value     ::= variable | constant | register | <expr> | array
                               | function | member
    
              (The IFB statement does not support <expr>, array, member, or
              function.) 
    
              This  sets  up  an  if-block. Condition is evaluated right to
              left with respect to OR/AND; Only four conditions may  appear
              on one line. 
    
    
    





                                      -36-                               4.6



    Vax Mp                      August 22, 1981                       Vax Mp


              Example:
    
                            IF a = b   AND  c = d   OR   e = f
    
              is equivalent to a ()'ed boolean
    
                               IF (a=b AND (c=d   OR (e=f)))
    
    
              The on/off are used for bit testing.
    
              Example:
    
                                      bit #4,variable
                                      IF ON
                                      ...
                                      FI
    
    
              Expressions  are  the  same  as in assignment statements, but
              must be inclosed in <>'s. 
    
              Example:
    
                    IF <a + b> GT <c - d>   AND   array[<i + 1>] NE #0
    
                    if a[0,b] =  `a'        ;these two are equivalent
                    ifb a  =  `a'           ;but ifb is more efficient
    
    
    
    o    ELSEIF(B) condition ...
    
    
              alternate if block, conditions as in an IF
    
    
    o    ELSE
    
              default selection within an IF block (must follow all
              elseif's)
    
    o    FI
    
              terminate an if block
    
    









                                      -37-                               4.6



    Vax Mp                      August 22, 1981                       Vax Mp


              Example:
    
                           IF this = r0    OR   foo NE 5
                              IF nested = example[function[i]]
                              ...
                              ELSEIF jim GT john
                              ...
                              ELSEIF jim LE john  AND i NE 1
                              ...
                              ELSE
                              ...
                              FI
    
                           ELSEIF autovar HIS parameter
                              ...
                           ELSE
                              ...
                           FI
    
    o    SELECT CASE variable OF
    
    
              introduce a case construct
    
    
    o    CASE(B) operand {OR}
    
              One or more case statements follow the select statement.
              Each selects a block of code conditionally by  comparing
              the   SELECT   variable   with  operand.  Multiple  case
              statements may be OR'd with a single block  of  code  by
              using  the  OR  keyword. The last case in the group does
              not have the  OR.  Note  that  a  BREAK  or  some  other
              transfer  of control must follow the block of code since
              `drop-thru' is undefined. 
    
              The  operand  is  anything  permitted in the destination
              field of a cmp(b) machine instruction. 
    
    
    o    DEFAULT
    
    
              executes the default code for a case statement.   This
              must be the last selector in the SELECT group.
    
    









                                      -38-                               4.6



    Vax Mp                      August 22, 1981                       Vax Mp


    o    ESAC
    
    
              terminates a case construct.
    
    
              Example:
    
    
                             SELECT case (r4) of
    
                               CASEB  `a'
                                  ...
                                  BREAK
    
                               CASEB  `b' OR
                               CASEB  `c'
                                  ...
                                  BREAK
    
                               DEFAULT
                             ESAC
    
              The  select/case  group  is  a  more  compact  form of a
              multiway IF block. However,  the  individual  selections
              must  be  terminated  by an explicit transfer of control
              (usually via a BREAK). 
    
    
    o    LOOP for indx = ini TO|DOWNTO|THRU|DOWNTHRU end {STEP amt}
    
                  indx ::= variable | register
                  ini  ::= <expr> | term
                  amt  ::= <expr> | term
                  end  ::= <expr> | term
    
              (THRU and DOWNTHRU generate unsigned branches)
    
    
    
              Negative going loops must supply  the  step  amount.  It
              defaults  to  1 (regardless of the existence of a DOWNTO
              or DOWNTHRU keyword). Loop is top tested; hence, a  loop
              may be iterated zero or more times. 
    











                                      -39-                               4.6



    Vax Mp                      August 22, 1981                       Vax Mp


    
    o    NEXT indx
    
    
              At  the  end of a loop body, this adds the step value to
              the  indx  and returns to the top of the loop.  indx  is
              checked for proper nesting. 
    
    
    
    
    
              Example:
    
    
                 LOOP for i := #alpha  THRU  #beta  STEP  2    ;step by words
    
                 ...
                     IF ...
                        BREAK                                  ;terminates loop
                     FI
                 NEXT i
    
    
    
    
    
    
    
    o    DO WHILE(B) if-condition
    
    
              Loop  as  long as condition is met. if-condition is an
              IF statement type condition. Loop is top tested. 
    
    
    o    DO {FOREVER}
    
              sets up an infinite loop which is only ended via  a  jmp
              or BREAK. The keyword FOREVER is optional.
    
    
    o    OD
    
    
              end of the do loop.
    
    
              Example:
    
                 DO FOREVER                      DO WHILE a = b
                   ...                              ...
                   BREAK IF a NE b               OD



                                      -40-                               4.6



    Vax Mp                      August 22, 1981                       Vax Mp


                 OD
    
    
    o    BREAK {IF(B) ...}
    
    
              This causes a controlled  jump  to  the  first  statement
              following  a  DO WHILE, DO FOREVER, LOOP, or SELECT CASE
              construct.  It leaves only the innermost  loop  or  case
              construct  currently  active.   If  an  IF  statement is
              supplied then it is equivalent to the form:
    
                      IF(B) ...
                         BREAK
                      FI
    
    
    4.7  Vax opcodes and Mp variables
    
         The  statement  processor also checks to see if the statement is a
         one to four operand vax instruction. This  it  determines  by  the
         argument  count  and the fact that it is not a defined macro or an
         opcode which begins with `.' (dot). If it is a vax opcode then the
         same rules for variables and constants apply here as well. That is
         it is NOT just output untouched but is translated into actual  vax
         type operands. For example: 
    
            f:      .word 0                 ;the `.' protected the 0
                                            ;from becoming #^o0
                    function test[d,e]
                    Auto a,b,c
                    {
    
                    movl 0377,e     ;generates movl #^O0377,e(ap)
                    movl 25,a       ;generates movl #^D<25>,a(fp)
                    addl3 25,a,b    ;generates addl3 #^D<25>,a(fp),b(fp)
                    ...
    
         This  means that if you define a macro for macro-32 to process and
         invoke it with operands like constants  and  variables  they  will
         also  be  modified  just  like the bit instruction. If this is not
         desired then the escape operation of i%dout must be used: 
    
                    i%dout <mymacro 0>      ;generates mymacro 0
                    ~       mymacro 0       ;works also
    
    
         This  feature can also be turned off via the /na switch. Note that
         only simple variables are  transformed,  that  is,  no  functions,
         double  quoted  strings (single quoted are ok), or expressions are
         allowed. 
    
         Since  Vms  makes  heavy use of keyword macros for system services



                                      -41-                               4.7



    Vax Mp                      August 22, 1981                       Vax Mp


         and Rms, a macro called ARGS  exists  which  will  check  for  the
         symbol  after the `=' and perform symbol transformations using the
         #@{x}  argument  expander  described  in  section  2.9.  Thus  for
         example: 
    
            ...
            Auto nblks
            Register addr
            External FabBlock
            ...
    
            $fab_store                                      -
                args fab=FabBlock alq=nblks                 -
                args fna=@addr    fns=20
            $create                                         -
                args fab=FabBlock
            ...
    
         In  this  example,  nblks,  addr  and  20 will be transformed into
         macro-32 syntax. 
    
         Note  the  `-'  at  the  end  of  continued  lines. The one on the
         $fab_store and $create lines are necessary, while the ones on  the
         args lines are only needed to continue the line. These hyphens are
         handled  by  mp  macros and thus must not be in contact with a `;'
         unlike the situation in macro-32. 
    
    
    4.8  Notes
    
         Some  stack  and  switch  dump macros exist as well: Dump, dmpstr,
         dmpsw, peek and poke. These are  usually  used  to  test  out  new
         macros  interactively. Setlab allows one to set the string used to
         make labels. 
    
         The macros make use of the two stacks  internally.  Stack  one  is
         used  for  all "IF" constructs and all others use stack 2. This is
         so that a BREAK can be nested inside an  IF  block  and  find  the
         innermost LOOP or CASE branch-to label.
    
















                                      -42-                               4.8



    Vax Mp                      August 22, 1981                       Vax Mp


    
         Stack usage is as follows:
    
    
    
    
                  If (stack 1)
                         tos     branch to on false
                         nos     go here on done (after elseif's etc)
    
                  case (stack 2)
                         tos     break to label
                         nos     variable to test
                         3os     skip over to next case test label
                         4os     Case true (the Or label)
    
                  Do while/forever (stack 2)
                         tos     break to
                         nos     jmp back to test or continue in loop label
    
                  loop (stack 2)
                         tos     break to
                         nos     jmp back to test for more looping label
                         3os     loop index
                         4os     step parameter
    
    
    4.9  optimizer
    
        The  code generated by the macros is in some cases rather poor. In
        the area of expressions and array/member references many temporary
        register  uses  can  be eliminated. Also, branching is designed to
        never have to worry about reaching code. Rather than slow down the
        macro generation or generate all short branches, it was felt  that
        an  optional optimizer pass could be called upon after a module is
        debugged. Thus good code generation and fast  translation  can  be
        both attained. 
    
        However, a peephole optimizer can be very difficult to write if it
        needs to rigorously analyse register usage. Instead, the optimizer
        for  MP  knows  the manner of usage of indivdual registers and can
        thus delete unecessary code or reduce the complexity  of  operands
        where a registers contents are known in advance. 
    
        For  example,  r0  and r1 are used in array calculations by always
        producing the subscript in r1 and then using index  mode  to  move
        the  value  of  the  array element into r0. The code generator can
        then simply view an array reference in the same way as a  function
        call. However, this usually generates code as follows: 
    
                    movl subscript,r1
                    movl array[r1],r0
                    movl r0,destination



                                      -43-                               4.9



    Vax Mp                      August 22, 1981                       Vax Mp


    
        This can be easily folded into the more efficient sequence: 
    
                    movl subscript,r1
                    movl array[r1],destination
    
        And  if  the subscript is the constant zero, then the macros would
        have generated the following: 
    
                    clrl r1
                    movl array[r1],r0
                    movl r0,destination
    
        This is optimised in two passes into the following: 
    
            first
                    movl array,r0           ;since [r1] is just 0
                    movl r0,destination
            second
                    movl array,destination  ;by above folding of r0
    
        Thus  a  personalized  peephole  optimizer  need  only  look   for
        sequences of MP code to produce rather good results. 
    
        However, if the user were to naivly generate code that expected r0
        to  stay  set,  then incorrect code could result. Thus in order to
        use the optimizer, the user should never manipulate r0  except  as
        follows: 
    
            First move r0 or r1 to another register as follows:
    
                    moval (r1),r2           ;same as movl r1,r2
                    moval (r0),r2           ;same as movl r0,r2
    
            To set r0 or r1 use the following:
    
                    addl3 r2,#0,r0
                    addl3 r2,#0,r1
    
    
            Also, the bits intrinsic function will work:
    
    
                    bits[r0,0,32] := x
    
                         or
    
                    x := bits[r1,0,32]
    
        But  notice  that the reference to r1 above will clobber r0. Also,
        one can create macro-32 macros or opcodes that are unknown to  the
        optimizer which can reference these registers. 
    



                                      -44-                               4.9



    Vax Mp                      August 22, 1981                       Vax Mp


        The  best  way  to  be sure is to check the modules opt*.mac which
        each describe the particular optimizations performed. 
    
        The branch optimizer is currently very simpleminded. It creates  a
        symbol  table using the information on the PROGRAM line to be able
        to spot internally  generated  labels.  Then  2  passes  are  made
        looking for word displacement branches that can be changed to byte
        displacement.  It guesses that byte branches can reach 50 lines in
        either direction. If an assembler error occurs use the -l#  option
        with a value less than 50 (or more if you dare). 
    
        The optimizer reads the  entire  file  (source.mpp)  into  virtual
        memory as a doubly linked list and makes about 14 passes (order is
        important)  modifing  the  code.  Finally it outputs the optimized
        version (source.opt). The command file op.com and the command:
    
    
                    @op source  [-option] [-option]  ...
    
        is used to run the program, and then run macro-32. The following
        options are supported:
    
                    -v      verbose
                    -l#     set the number of lines assumed to be
                            reachable with a short branch to #.
                    -o#     do only pass # (for debugging mostly)
    
    




























                                      -45-                               4.9



    Vax Mp                      August 22, 1981                       Vax Mp


    
    5.   Language Summary
    
    
               PROGRAM string
               FUNCTION parameter-label*
               AUTO  label+
               REGISTER  label+
               EXTERNAL  label+
               RETURN  {Expression}
    
               STRUCT name
               MEMBER name+
               END-STRUCT {name}
    
               destination := term  {operator term}*
    
               IF|IFB condition {OR|AND condition ...
               IF condition-code
               ELSEIF(B) condition ...
               ELSE
               FI
    
               SELECT CASE variable OF
               CASE(B) operand {OR}
               DEFAULT
               ESAC
    
               LOOP FOR indx = ini TO|DOWNTO|THRU|DOWNTHRU end {STEP amt}
               NEXT indx
    
               DO WHILE(B) if-condition
               DO FOREVER
               OD
    
               BREAK {IF(B) ...}
    
               PUSH|POP  variable


















                                      -46-                               5.0



    Vax Mp                      August 22, 1981                       Vax Mp


    6.  Alternate built in macro libraries
    
    
         The  default  library  is  built in at task build time. The module
         mcmd.mac contains a macro called "mc". This  module  is  assembled
         with  all text for a macro library as calls to the "mc" macro (one
         per line of macros in the library). The  "mc"  macro  simply  puts
         some  pointers  around  the  text  which  is  assembled  as .ascii
         statements. Then at run time, these are loaded from an overlay and
         scanned (as if they came from a file). The main  reason  for  this
         method  of  loading  is speed. Note that the /NI switch suppresses
         this loading. Useful when testing out a new  library.  The  module
         mcmd.mac is assembled as: 
    
                              >mcr mac  mcmd=mcmd.
    
         Then the MP task is rebuilt: 
    
                              >mcr tkb @mp.bld.
    
         The mcmd.obj module is NOT put in a library. 
    
         One other source module is available which has  some  labels  that
         allocate  more  or  less  storage for various mp internals and the
         area for storage of macro text. Use the /un switch to measure  the
         remaining  storage  available  after  a library is loaded. If many
         levels  of  recursive  macro  expansion  are  required,  bump  the
         stack=xxx  in  the  build file. The amount of storage used is kept
         track of and the lowest sp value detected is output at the end  of
         each  run.  Running out of space may cause program failures, so be
         generous. The module stak.mac also contains storage which  can  be
         increased. It is assembled thus: 
    
                             >mcr mac stak=ml/ml,stak.
    
         It  also is not put into a library. If the processor blows up when
         trying to initialize itself (loading default macros) use  the  /is
         switch  to  have  the  lines echoed on the tty so one may see what
         line in the mcmd.mac file caused the problem. If the program  runs
         out  of space for macro library text it usually just crashes. Bump
         the amount of text (in bytes) and the number of lines allowed  for
         macros. 
    
         Note that some macros have been coded directly into the source for
         increased  speed.  Even  with  a  totally redefined default set of
         macros, one would still have a few built in macros. If  one  needs
         to  get  rid  of these too, then the best way is to find the table
         macro call (which enters  the  name  into  the  opcode  table)  in
         stak.mac  and  change  the macro from table to NOtable. Since some
         routines in the let*.mac group have found uses in  other  modules,
         it  is best to leave the source code alone, even though most of it
         would then no longer be used. Special care must be taken to  place
         any  new  modules  on the main overlay path with all the recursive



                                      -47-                               6.0



    Vax Mp                      August 22, 1981                       Vax Mp


         routines (the path with stat* and let*). New opcodes can be  added
         by  finding  a  slot  in stak.mac and then placing an entry in the
         corresponding  dispatch  table  in  stat.mac.  The  slots  can  be
         extended  at  the end also simply by adding an entry at the end of
         each table (the assembler will compute the number of entrys in the
         each). 
    
         The  task  build  file for Mp also contains global definitions for
         the various characters used to delimit parameters. If  one  wishes
         to  have  >  and >= etc. as operators instead of GT or GE then the
         enclosing brackets would need to be changed from <>'s to something
         else, say for example {}'s. Any macro library used would of course
         have to  conform  to  these  characters  as  well.  The  character
         definitions for the unary operators also are found there. 
    
         Note  that  any  change in the delimiter characters would probably
         result in some Macro-32  incompatibility.
    
    
    6.1 Modifications to internals
    
         Most sources  for vax mp are written in a prior version of mp that
         generates pdp11 code. The pdp11 version is not compatible with the
         vax version, although its close. Many poor design  decisions  were
         corrected  in  the  vax  version.  In  order to rebuild any of the
         sources for vax mp,  one  must  use  the  image  rmp.exe  and  the
         following commands: 
    
                    rmp file/lm/nb/nl
                    mcr mac file=file.mpp
    
         this will translate file.mac into file.obj. 
    
         All global storage for stacks, opcodes,  and  numerical  data  are
         found in stak.mac. 
    
         The following lists some of the modules that may be of interest to
         a user who wishes to modify vax mp. 
    
            stat            statement expander - recursive decent parser
            stat1           opcode lookup (hash tables etc)
            stat2           string stack operators
            stat3           assignment := parsing
    
            let,let1-3      various portions of the assignment statement
    
            sub             parameter expansion and substitution
    
            hards           secondary dispatcher for hardcoded macros
    
            macexp          macro expansion module
            nums            internal numerical variables and s%n exprs
    



                                      -48-                               6.1



    Vax Mp                      August 22, 1981                       Vax Mp


         The rmp.exe image is built from the spring 1981 rsx decus tape.
    






















































                                      -49-                               6.1



    Vax Mp                      August 22, 1981                       Vax Mp


    7.0 Examples
    
         The  following  is  an  example  of  a  Macro  created to supply a
         construct similar to the C and Ratfor FOR loop. Recall the  syntax
         of the FOR is: 
    
            For (initialize ; test ; reinitialize)
               statement
    
         The  easiest  way  to  implement  this statement, is to modify the
         syntax to keep within the allowable constructs  of  MP.  Thus  our
         version will be: 
    
    
    
            FOR <initialize> <WHILE(B) test> <reinitialize>
    
            ROF
    
         Any of the three parts of a FOR loop  may  be  null  and  will  be
         interpreted as in C and RATFOR. 
    
         Note  the requirement that the keyword WHILE(B) be explicit in the
         test part of the macro call. This  is  to  avoid  needing  a  FORB
         macro.  The  following  macro definitions supply such a statement,
         using the already existing macros in the default  macro  library.
    
         The  initialize  part  is  expanded on a line by itself. The i%din
         statement is used since the expansion can be any statement at  all
         (even an assignment statement). 
    
         The test part is converted into a DO WHILE(B) loop.  If  the  test
         part  is  null,  then  it  is  converted  into  FOREVER  which  is
         consistent with the definition of the FOR loop. This  is  done  by
         placing  either  parameter  2  onto  the  stack or if it was null,
         FOREVER is pushed there. Then the stack is poped   into  parameter
         2 replacing any previous contents. 
    
         The reinitialize part of the call is pushed in its  entirety  onto
         the  string  stack.  The  ROF  macro simply pops the statement and
         expands it. All the leg work for label generation  is  handled  by
         the DO and OD macros. 
    













                                      -50-                               7.0



    Vax Mp                      August 22, 1981                       Vax Mp


    
                       $MACRO FOR <init-1> <condition-2> <reinit-3>
                       i%din <#@1>
                       I%B  <#@2> <?- FOREVER>  <?- <#@2>>
                       ?+ 2
                       DO  #@2
                       ?- <#@3>
                       $ENDM
    
    
    
                       $MACRO ROF
                       ?+ 1
                       i%din <#@1>
                       OD
                       $ENDM
    
         A valid macro call using this construct could be: 
    
    
                        FOR <i := 0> <WHILE i LT 10> <incl i>
                        ...
                        ROF

































                                      -51-                               7.0



    Vax Mp                      August 22, 1981                       Vax Mp


    
         The  following  program  demonstrates  using  some  of  the system
         library routines under Vms and is presented as a sample program. 
    
    
              program print r5                      ;local use of r4 and r3
    
              function print[string,arg1]           ;print formatted string
              auto out[520,bytes],len
              register bbb
              {
                   bbb := desc[&out,520]                 ;build a descriptor
                   r4 := sys$faol[string,&out,bbb,&arg1] ;address of arg1 is
                   r3 := lib$put_output[bbb]             ;address of the
              }                                          ;actual parameter block
    
    
    
              function desc[of,len]                      ;builds descriptors
              {                                          ;for strings
                  of[0] := len
                  of[2,b] := 14
                  of[3,b] := 2
                  of[1] := of + 8
                  return of
              }
    
    
              function syserr[str,number]                ;looks up a system
              auto buf[200,bytes],len,stat2              ;error code and outputs
              {                                          ;text with an optional
                  desc[&buf,200]                         ;user string
                  sys$getmsg[number,&len,&buf,1,&stat2]  ;trans error to ascii
                  buf[0,w] := len                        ;set length
                  if str = 0
                     print["__!AS",&buf]                 ;just print error
                  else
                     print["__!AS !AS",str,&buf]         ;print err and user
                  fi                                     ;string
              }
              .end
    














                                      -52-                               7.0



    Vax Mp                      August 22, 1981                       Vax Mp


    
        The  following  code  is  generated from the above. Note the label
        generation uses label=. rather than label: so local symbol  blocks
        are  not affected.  This output is after the optimizer pass.
    
    ;        Mpvax version: 23-July-81 translation: 08-AUG-81 16:13:01
                    .ident          /08-AUG-81_16:13:01/
    
                    .disable                global
                    .enable         debug,suppression
                    .title          print
    
                    _temp_          = -10
                    _top_           = .
                    _auto_          = _temp_
    
    
    ; Function print[string,arg1]
    
                    _auto_          = _temp_
                    .long           2
    
                    string          =       4
                    arg1            =       8
    
                    .entry          print,^m<r2,r3,r4,r5,r6,r7,r8,r9,r10,r11>
                    _auto_          = _auto_-<<520>*1>
                    out             =       _auto_
    
                    _auto_          = _auto_-4
                    len             =       _auto_
    
    
                    addl            #_auto_,sp
    
                    pushl           #^D<520>
                    pushal          out(fp)
                    calls           #2,desc
                    movl            r0,r11
                    pushal          arg1(ap)
                    pushl           r11
                    pushal          out(fp)
                    pushl           string(ap)
                    calls           #4,sys$faol
                    movl            r0,r4
                    pushl           r11
                    calls           #1,lib$put_output
                    movl            r0,r3
                    ret
    
    
    
    



                                      -53-                               7.0



    Vax Mp                      August 22, 1981                       Vax Mp


    ; Function desc[of,len]
    
                    _auto_          = _temp_
                    .long           2
    
                    of              =       4
                    len             =       8
    
                    .entry          desc,^m<r2,r3,r4,r5,r6,r7,r8,r9,r10,r11>
    
                    addl            #_auto_,sp
    
                    moval           @of(ap),r5      
                    movl            len(ap),(r5)
                    movl            #^D<2>,r1
                    movab           @of(ap)[r1],r5  
                    movb            #^D<14>,(r5)
                    movl            #^D<3>,r1
                    movab           @of(ap)[r1],r5  
                    movb            #^D<2>,(r5)
                    movl            #^D<1>,r1
                    moval           @of(ap)[r1],r5  
                    movl            of(ap),r6
                    addl            #^D<8>,r6
                    movl            r6,(r5)
                    movl            of(ap),r0
                    ret
    
    ; Function syserr[str,number]
    
                    _auto_          = _temp_
                    .long           2
    
                    str             =       4
                    number          =       8
    
                    .entry          syserr,^m<r2,r3,r4,r5,r6,r7,r8,r9,r10,r11>
                    _auto_          = _auto_-<<200>*1>
                    buf             =       _auto_
    
                    _auto_          = _auto_-4
                    len             =       _auto_
    
                    _auto_          = _auto_-4
                    stat2           =       _auto_
    
    
                    addl            #_auto_,sp
    
                    pushl           #^D<200>
                    pushal          buf(fp)
                    calls           #2,desc
                    pushal          stat2(fp)



                                      -54-                               7.0



    Vax Mp                      August 22, 1981                       Vax Mp


                    pushl           #^D<1>
                    pushal          buf(fp)
                    pushal          len(fp)
                    pushl           number(ap)
                    calls           #5,sys$getmsg
                    movaw           buf(fp),r5      
                    movw            len(fp),(r5)
                    cmpl            str(ap),#^O0
                    Bneq            print1          
    print4=.
                    .save
                    .psect          textstrings
    print5=.
                    .ASCID          _!AS_
                    .byte           0
                    .restore
                    pushal          buf(fp)
                    pushal          print5
                    calls           #2,print
                    brb             print6          
    print1=.
                    .save
                    .psect          textstrings
    print7=.
                    .ASCID          _!AS !AS_
                    .byte           0
                    .restore
                    pushal          buf(fp)
                    pushl           str(ap)
                    pushal          print7
                    calls           #3,print
    print6=.
    print3=.
                    ret
    ;%%reg%% 5 11
                    .end            




















                                      -55-                               7.0



    Vax Mp                      August 22, 1981                       Vax Mp


    
        program tape r5
    
    
        function tape
        auto buf[1000,b],chan
        {
            chan :=    mtassign[ref[0]]          ;assign channel quietly
            print["__ size = !SL",taperead[ref[chan],&buf,ref[1000],ref[0]]]
        }
    
    
        function mtassign[verbose]                 ;call by ref for fortran use
        auto chan,s
        {
            s := sys$assign["__MTA0",&chan,0,0]
            if @verbose = 1
                    syserr["__assign to mt returns=",s]
            fi
            return chan
        }
    
        function taperead[chan,buf,size,verbose]    ;also call by ref
        auto ios[4,w],s                             ;so use @chan etc.
        {
    
            s := sys$qiow[1,@chan,#io$_readlblk,&ios,0,0,buf,@size,0,0,0,0]
            if @verbose = 1                 ;print info if asked
                syserr["__qio returns=",s]
                print["__ios is`!UW !UW'",ios[0,w],ios[1,w]]
                print["__buf is`!OW !OW'",buf[0,w],buf[1,w]]
                syserr["__ios block of qio=",ios]
            fi
            if ios[0,w] ne #ss$_normal
                return -1                   ;return -1 on eof or error
            else
                return ios[1,w]             ;else the record size if ok
            fi
        }
        .end  tape
















                                      -56-                               7.0



    Vax Mp                      August 22, 1981                       Vax Mp


    ;        Mpvax version: 23-July-81 translation: 08-AUG-81 16:04:39
                    .ident          /08-AUG-81_16:04:39/
    
                    .disable        global
                    .enable         debug,suppression
                    .title          tape
    
                    _temp_          = -10           ;start of local vars
                    _top_           = .
                    _auto_          = _temp_        ;init local counter
    
    ; Function tape[]
    
                    _auto_          = _temp_        ;init local storage counter
                    .long           0               ;number of arguments
    
                    .entry          tape,^m<r2,r3,r4,r5,r6,r7,r8,r9,r10,r11>
                    _auto_          = _auto_-<<1000>*1>
                    buf             =       _auto_
    
                    _auto_          = _auto_-4
                    chan            =       _auto_
    
                    addl            #_auto_,sp      ;allocate local storage
    
                    .save
                    .psect          temps
    tape1:          .long 0
                    .restore
                    clrl            tape1
                    pushal          tape1           
                    calls           #1,mtassign
                    movl            r0,chan(fp)
                    .save
                    .psect          textstrings
    tape2=.
                    .ASCID          _ size = !SL_
                    .byte           0 ;null terminate also
                    .restore
                    .save
                    .psect          temps
    tape3:   .long 0
                    .restore
                    clrl            tape3
                    pushal          tape3           
                    .save
                    .psect          temps
    tape4:   .long 0
                    .restore
                    movl            #^D<1000>,tape4
                    pushal          tape4           
                    pushal          buf(fp)
                    .save



                                      -57-                               7.0



    Vax Mp                      August 22, 1981                       Vax Mp


                    .psect          temps
    tape5:   .long 0
                    .restore
                    movl            chan(fp),tape5
                    pushal          tape5           
                    calls           #4,taperead
                    pushl           r0      
                    pushal          tape2
                    calls           #2,print
                    ret
    
    ; Function mtassign[verbose]
    
                    _auto_          = _temp_ ;init local storage counter
                    .long           1                       ;number of arguments
    
                    verbose         =       4
    
                    .entry          mtassign,^m<r2,r3,r4,r5,r6,r7,r8,r9,r10,r11>
                    _auto_          = _auto_-4
                    chan            =       _auto_
    
                    _auto_          = _auto_-4
                    s               =       _auto_
    
                    addl            #_auto_,sp ;allocate local storage
    
                    .save
                    .psect          textstrings
    tape6=.
                    .ASCID          _MTA0_
                    .byte           0 ;null terminate also
                    .restore
                    pushl           #^O0
                    pushl           #^O0
                    pushal          chan(fp)
                    pushal          tape6
                    calls           #4,sys$assign
                    movl            r0,s(fp)
                    cmpl            @verbose(ap),#^D<1>
                    Bneq            tape7           
    tape10=.
                    .save
                    .psect          textstrings
    tape11=.
                    .ASCID          _assign to mt returns=_
                    .byte           0 ;null terminate also
                    .restore
                    pushl           s(fp)
                    pushal          tape11
                    calls           #2,syserr
    tape7=.
    tape9=.



                                      -58-                               7.0



    Vax Mp                      August 22, 1981                       Vax Mp


                    movl            chan(fp),r0
                    ret
    
    ; Function taperead[chan,buf,size,verbose]
    
                    _auto_          = _temp_ ;init local storage counter
                    .long           4                       ;number of arguments
    
                    chan            =       4
                    buf             =       8
                    size            =       12
                    verbose         =       16
    
                    .entry          taperead,^m<r2,r3,r4,r5,r6,r7,r8,r9,r10,r11>
                    _auto_          = _auto_-<<4>*2>
                    ios             =       _auto_
    
                    _auto_          = _auto_-4
                    s               =       _auto_
    
                    addl            #_auto_,sp ;allocate local storage
    
                    pushl           #^O0
                    pushl           #^O0
                    pushl           #^O0
                    pushl           #^O0
                    pushl           @size(ap)
                    pushl           buf(ap)
                    pushl           #^O0
                    pushl           #^O0
                    pushal          ios(fp)
                    pushl           #io$_readlblk
                    pushl           @chan(ap)
                    pushl           #^D<1>
                    calls           #12,sys$qiow
                    movl            r0,s(fp)
                    cmpl            @verbose(ap),#^D<1>
                    Bneq            tape12          
    tape15=.
                    .save
                    .psect          textstrings
    tape16=.
                    .ASCID          _qio returns=_
                    .byte           0 ;null terminate also
                    .restore
                    pushl           s(fp)
                    pushal          tape16
                    calls           #2,syserr
                    .save
                    .psect          textstrings
    tape17=.
                    .ASCID          _ios is`!UW !UW'_
                    .byte           0 ;null terminate also



                                      -59-                               7.0



    Vax Mp                      August 22, 1981                       Vax Mp


                    .restore
                    movl            #^D<1>,r1
                    cvtwl           ios(fp)[r1],-(sp)               
                    cvtwl           ios(fp),-(sp)           
                    pushal          tape17
                    calls           #3,print
                    .save
                    .psect          textstrings
    tape18=.
                    .ASCID          _buf is`!OW !OW'_
                    .byte           0 ;null terminate also
                    .restore
                    movl            #^D<1>,r1
                    cvtwl           @buf(ap)[r1],-(sp)              
                    cvtwl           @buf(ap),-(sp)          
                    pushal          tape18
                    calls           #3,print
                    .save
                    .psect          textstrings
    tape19=.
                    .ASCID          _ios block of qio=_
                    .byte           0 ;null terminate also
                    .restore
                    pushl           ios(fp)
                    pushal          tape19
                    calls           #2,syserr
    tape12=.
    tape14=.
                    cvtwl           ios(fp),r5      
                    cmpl            r5,#ss$_normal
                    Beql            tape20          
    tape23=.
                    movl            #^D<-1>,r0
                    ret
                    brb             tape24          
    tape20=.
                    movl            #^D<1>,r1
                    cvtwl           ios(fp)[r1],r5  
                    movl            r5,r0
                    ret
    tape24=.
    tape22=.
                    ret
    ;%%reg%% 5 11                                   ;used by optimizer
                    .end            tape











                                      -60-                               7.0



    Vax Mp                      August 22, 1981                       Vax Mp


                                        6.  alternate built in macro libraries
                                 2.9 macro  argument operators
                 2.7 macro definitions and  arguments
                              6. alternate  built in macro libraries
                                        4.  built in macros
                         2.4 variables and  conditionals
                                       4.4  constants
                                       4.3  data types
                                       4.5  declarative statements
                                 2.7 macro  definitions and arguments
                              4.1 language  description
                                2. what mp  does
                                        7.  examples
                                       4.6  executable statements
                              3. operating  instructions
                               2.5 more on  internal statements
                      6.1 modifications to  internals
                                        1.  introduction
                                       4.1  language description
               6. alternate built in macro  libraries
                                       2.9  macro argument operators
                                       2.7  macro definitions and arguments
                     6. alternate built in  macro libraries
                                        5.  macro summary
                                   2.2 the  macros
                      2.3 treatment of non  macros
                               4. built in  macros
                                       6.1  modifications to internals
                                       2.5  more on internal statements
                                   2. what  mp does
                       4.7 vax opcodes and  mp variables
                          2.3 treatment of  non macros
                                       4.8  notes
                                   4.7 vax  opcodes and mp variables
                                        3.  operating instructions
                        2.9 macro argument  operators
                                   2.1 the  pass
                                       4.2  program structure.
                            2.8 the string  stack
                      2.5 more on internal  statements
                           4.5 declarative  statements
                            4.6 executable  statements
                                   2.8 the  string stack
                               4.2 program  structure.
                                  5. macro  summary
                                       2.6  switches
                                       2.3  treatment of non macros
                                  4.3 data  types
                                       2.4  variables and conditionals
                    4.7 vax opcodes and mp  variables
                                       4.7  vax opcodes and mp variables
                                        2.  what mp does




                                      -61-                               7.0

