	PROGRAM FINDALL
C
C	A program to look at the file INDEXF.SYS and list all of the
C	files for the current UIC.
C
	IMPLICIT REAL*16 (A-Z)
C
C	Data definitions for Command line Parsing
C	LINE    -- Input line from the command processor
C	LINEL   -- Length of input line
C	OLEN    -- Residual length of input line parsed
C	DEVNAME -- Device name to use
C	FIDFLG  -- If .TRUE., output the file id
C	SIZFLG  -- If .TRUE., output the file size
C	ANYGRP  -- If .TRUE., allow any group number to match
C	ANYMEM  -- If .TRUE., allow any member number to match
C	UIC     -- File owner to match to
C	UIC2    -- Equivalent name for UIC
C	DEVFLG  -- If .TRUE., a device name has been supplied
C	DEVLEN  -- Device name length
C
	CHARACTER*255 LINE
	INTEGER LINEL
	INTEGER*4 OLEN
C
	CHARACTER*255 DEVNAME
	COMMON /FINDSTR/DEVNAME
C
	LOGICAL*4 FIDFLG,SIZFLG
	INTEGER*4 MINSIZ,MAXSIZ
	LOGICAL*4 ANYGRP,ANYMEM
	INTEGER*4 UIC
	INTEGER*2 UIC2(2)
	EQUIVALENCE (UIC,UIC2)
	LOGICAL*4 DEVFLG
	INTEGER*4 DEVLEN
	COMMON /FINDARG/FIDFLG,SIZFLG,MINSIZ,MAXSIZ,ANYGRP,ANYMEM,UIC,
	1 DEVFLG,DEVLEN
C
	BYTE IBMAP(0:4097)
	INTEGER IBLEN
C
C	Index Bit Map Goodies
C	IBMAP -- Index Bit Map (copied from INDEXF.SYS)
C	IBLEN -- Length of Bit Map
C
	BYTE IREC(0:511)
C
C	Data Definitions for the Home Block
C	HM2$W_STRUCLEV  -- Structure level of the disk
C	 HM2$C_LEVEL2   -- Value of STRUCLEV for ODS-2 disk packs
C	HM2$W_CLUSTER   -- Cluster size on the pack
C	HM2$W_IBMAPVBN  -- Index Bit Map Virtual Block Number
C	HM2$L_MAXFILES  -- Maximum Number of file headers in index file
C	HM2$W_IBMAPSIZE -- Index Bit Map Size
C	HM2$W_RESFILES  -- Number of reserved files on the disk
C
	INTEGER*2 HM2$W_STRUCLEV,HM2$W_CLUSTER,HM2$W_IBMAPSIZE
	INTEGER*2 HM2$W_RESFILES,HM2$W_IBMAPVBN
	INTEGER*4 HM2$L_MAXFILES
	EQUIVALENCE (IREC('0C'X),HM2$W_STRUCLEV)
	EQUIVALENCE (IREC('0E'X),HM2$W_CLUSTER)
	EQUIVALENCE (IREC('16'X),HM2$W_IBMAPVBN)
	EQUIVALENCE (IREC('1C'X),HM2$L_MAXFILES)
	EQUIVALENCE (IREC('20'X),HM2$W_IBMAPSIZE)
	EQUIVALENCE (IREC('22'X),HM2$W_RESFILES)
C
	INTEGER*2 HM2$C_LEVEL2
	PARAMETER (HM2$C_LEVEL2 = '0201'X)
C
C	Data Definitions for the File Headers
C	FH2$B_IDOFFSET  -- Index to Identification Area
C	FH2$W_FID_NUM   -- File ID Number
C	FH2$W_FID_SEQ   -- File Sequence Number
C	FH2$W_FID_RVN   -- File Relative Volume Number
C	FH2$W_EXT_NUM   -- Extension File ID Number
C	FH2$W_EXT_SEQ   -- Extension File Sequence Number
C	FH2$W_EXT_RVN   -- Extension File Relative Volume Number
C	FAT$L_HIBLK     -- Number of blocks allocated
C	FAT$L_EFBLK     -- End of file block
C	FH2$L_FILEOWNER -- Owner uic of the file
C	FH2$W_UICMEMBER -- Member portion of the file owner
C	FH2$W_UICGROUP  -- Group portion of the file owner
C	FH2$W_BK_FIDNUM -- Back Link File ID Number
C	FH2$W_BK_FIDSEQ -- Back Link File Sequence Number
C	FH2$W_BK_FIDRVN -- Back Link File Relative Volume Number
C	FI2$T_FILENAME  -- Offset of filename into ID area
C	
	BYTE FH2$B_IDOFFSET
	INTEGER*2 FH2$W_FID_NUM,FH2$W_FID_SEQ,FH2$W_FID_RVN
	INTEGER*2 FH2$W_EXT_NUM,FH2$W_EXT_SEQ,FH2$W_EXT_RVN
	INTEGER*2 FAT$L_HIBLK(2),FAT$L_EFBLK(2)
	INTEGER*4 FH2$L_FILEOWNER
	INTEGER*2 FH2$W_UICMEMBER,FH2$W_UICGROUP
	INTEGER*2 FH2$W_BK_FIDNUM,FH2$W_BK_FIDSEQ,FH2$W_BK_FIDRVN
C
	EQUIVALENCE (IREC('00'X),FH2$B_IDOFFSET)
	EQUIVALENCE (IREC('08'X),FH2$W_FID_NUM)
	EQUIVALENCE (IREC('0A'X),FH2$W_FID_SEQ)
	EQUIVALENCE (IREC('0C'X),FH2$W_FID_RVN)
	EQUIVALENCE (IREC('0E'X),FH2$W_EXT_NUM)
	EQUIVALENCE (IREC('10'X),FH2$W_EXT_SEQ)
	EQUIVALENCE (IREC('12'X),FH2$W_EXT_RVN)
	EQUIVALENCE (IREC('18'X),FAT$L_HIBLK)
	EQUIVALENCE (IREC('1C'X),FAT$L_EFBLK)
	EQUIVALENCE (IREC('3C'X),FH2$L_FILEOWNER,FH2$W_UICMEMBER)
	EQUIVALENCE (IREC('3E'X),FH2$W_UICGROUP)
	EQUIVALENCE (IREC('42'X),FH2$W_BK_FIDNUM)
	EQUIVALENCE (IREC('44'X),FH2$W_BK_FIDSEQ)
	EQUIVALENCE (IREC('46'X),FH2$W_BK_FIDRVN)
C
	INTEGER FI2$T_FILENAME
	PARAMETER (FI2$T_FILENAME='00'X)
C
C	Local variables
C	I,J,K     -- Simple loop indicies
C	II        -- Array index for the Index Bit Map
C	IND       -- Array index for the Index Bit Map
C	INDOFF    -- Index file header offset
C	RESMAX    -- Offset to last Reserved File
C	MAXFILES  -- Maximum Number of File Headers
C	ITEMS     -- Item list for GETJPI system service
C	ITEM2     -- Synonym for ITEMS (I*2 array)
C	SFILE     -- String version of filename
C	BFILE     -- Byte array version of filename
C	BFILEL    -- Length of filename.
C	FIDNUM    -- File ID number for file
C	FIDSEQ    -- File Sequence Number for file
C	FIDRVN    -- Relative Volume number for file
C	EFSIZE    -- Size of file to end of file
C	ALSIZE    -- Size of file by allocation
C	EFSIZE2   -- I*2 equivalence to EFSIZE
C	ALSIZE2   -- I*2 equivalence to ALSIZE
C	GROUP     -- Current file group number
C	MEMBER    -- Current file member number
C	MFDNUM    -- File ID number for MFD
C	MFDSEQ    -- File Sequence Number for MFD
C	MFDRVN    -- Relative Volume Number for MFD
C	DIRMAX    -- Maximum number of directories seen
C	DIRFID    -- File ID's for Directories
C	DIRNAME   -- Name of Directories
C	DIRLEN    -- Length of directory name
C	DIRIND    -- Directory index
C	SUBIND    -- Subdirectory index
C	OUTOPT    -- Output options
C
	INTEGER I,J,K
	INTEGER II,IND
	INTEGER INDOFF
	INTEGER RESMAX
	INTEGER MAXFILES
	INTEGER*4 ITEMS(4)
	INTEGER*2 ITEM2(8)
	EQUIVALENCE (ITEMS,ITEM2)
	CHARACTER*19 SFILE
	BYTE BFILE(19)
	EQUIVALENCE (SFILE,BFILE)
	INTEGER BFILEL
	INTEGER*2 FIDNUM,FIDSEQ,FIDRVN
	INTEGER*4 EFSIZE,ALSIZE
	INTEGER*2 EFSIZE2(2),ALSIZE2(2)
	EQUIVALENCE (EFSIZE,EFSIZE2)
	EQUIVALENCE (ALSIZE,ALSIZE2)
	INTEGER*2 GROUP,MEMBER
	INTEGER*2 MFDNUM,MFDSEQ,MFDRVN
	INTEGER DIRMAX
	INTEGER*2 DIRFID(3,10000)
	EQUIVALENCE (DIRFID(1,1),MFDNUM)
	EQUIVALENCE (DIRFID(2,1),MFDSEQ)
	EQUIVALENCE (DIRFID(3,1),MFDRVN)
	CHARACTER*128 DIRNAME(10000)
	INTEGER*2 DIRLEN(10000)
	INTEGER DIRIND,SUBIND
	INTEGER OUTOPT
C
C	External subroutines and values
C	ISTAT          -- Status code from System Service calls
C	SYS$TRNLOG     -- Translate Logical Name System Service
C	SYS$GETJPI     -- Get Job/Process Information
C	LIB$FFS        -- Find first Set bit
C	SS$_NOTRAN     -- Status code for "No Translation"
C	LIB$_NOTFOU    -- No bits found
C	JPI$_UIC       -- UIC code needed
C	OKHEADER       -- File Header validator
C	COMSCAN        -- Command line scanner
C
	INTEGER*4 ISTAT
	INTEGER*4 SYS$TRNLOG,SYS$GETJPI
	INTEGER*4 LIB$FFS
	EXTERNAL SS$_NOTRAN,JPI$_UIC
	EXTERNAL LIB$_NOTFOU
	LOGICAL OKHEADER,COMSCAN
C
C	Initial values for local variables
C
	DATA ITEM2/4,7*0/
C
C	Get the UIC to process and set default device name
C
	ITEM2(2) = %LOC(JPI$_UIC)
	ITEMS(2) = %LOC(UIC)
	ISTAT = SYS$GETJPI(,,,ITEMS,,,)
	IF (.NOT.ISTAT) CALL SYS$EXIT(%VAL(ISTAT))
	DEVLEN = 9
	DEVNAME(1:DEVLEN) = 'SYS$DISK:'
C
C	Get the command line and parse it
C
	CALL LIB$GET_FOREIGN(LINE,'Device: ',LINEL)
	IF (LINEL.EQ.0) GOTO 7
	CALL STR$UPCASE(LINE(1:LINEL),LINE(1:LINEL))
	ISTAT = COMSCAN(LINE(1:LINEL),OLEN)
	IF (.NOT.ISTAT) THEN
	 WRITE(*,5) LINE(1:LINEL)
5	FORMAT(' Error with command line:',/,1X,A,/,<LINEL-OLEN+1>X,'^')
	 CALL SYS$EXIT(%VAL(1))
	ENDIF
C
C	Generate the output option number for later use
C
7	OUTOPT = 0
	IF (FIDFLG) OUTOPT = 1
	IF (SIZFLG) OUTOPT = OUTOPT+2
	OUTOPT = OUTOPT+1
C
C	Translate the device name if needed
C
10	CONTINUE
	LINEL = DEVLEN
	LINE(1:LINEL) = DEVNAME(1:DEVLEN)
	ISTAT = SYS$TRNLOG(LINE(1:LINEL),DEVLEN,DEVNAME,,,)
	IF (.NOT.ISTAT) CALL SYS$EXIT(%VAL(ISTAT))
	IF (ICHAR(DEVNAME(1:1)).EQ.27) THEN
	 LINEL = DEVLEN-4
	 LINE(1:LINEL) = DEVNAME(5:DEVLEN)
	ELSE
	 LINEL = DEVLEN
	 LINE(1:LINEL) = DEVNAME(1:DEVLEN)
	ENDIF
	IF (ISTAT.NE.%LOC(SS$_NOTRAN)) GOTO 10
C
C	Open the index file on the specified device
C
	OPEN(UNIT=1,FILE=LINE(1:LINEL) // '[0,0]INDEXF.SYS',ERR=990,
	1 READONLY,SHARED,STATUS='OLD',ACCESS='DIRECT',FORM='UNFORMATTED',
	2 RECORDTYPE='FIXED')
C
C	Read the home block and determine the location of the first
C	index block and the range of reserved files.
C	INDOFF = 4*(cluster size)+(size of index bit map)+1
C	RESMAX = INDOFF+(number of reserved files)-1
C
	READ(1,REC=2,ERR=970) IREC
	IF (HM2$W_STRUCLEV.NE.HM2$C_LEVEL2) GOTO 960
	INDOFF = HM2$W_CLUSTER*4+HM2$W_IBMAPSIZE+1
	RESMAX = HM2$W_RESFILES+INDOFF-1
C
C	Read in the Index Bit Map and Save Number of Headers
C
	MAXFILES = HM2$L_MAXFILES
	IF (MAXFILES.GT.32768) GOTO 950
	J = HM2$W_IBMAPVBN
	K = J+HM2$W_IBMAPSIZE-1
	IND = 0
	DO I=J,K
	 READ(1,REC=I,ERR=980) (IBMAP(II), II=IND,IND+511)
	 IND = IND+512
	ENDDO
C
C	Look for 000000.DIR and when found, record its FID.
C
	DO I=INDOFF,RESMAX
	 READ(1,REC=I,ERR=980) IREC
	 J = FH2$B_IDOFFSET*2+FI2$T_FILENAME
	 DO K=J,J+13
	  IF (CHAR(IREC(K)).EQ.';') THEN
	   BFILEL = K-J
	   GOTO 110
	  ELSE
	   BFILE(K-J+1) = IREC(K)
	  ENDIF
	 ENDDO
110	 CONTINUE
	 IF (SFILE(1:BFILEL).EQ.'000000.DIR') THEN
	  MFDNUM = FH2$W_FID_NUM
	  MFDSEQ = FH2$W_FID_SEQ
	  MFDRVN = FH2$W_FID_RVN
	  GOTO 120
	 ENDIF
	ENDDO
	WRITE(*,115)
115	FORMAT(' Cannot find file 000000.DIR in reserved file section')
	GOTO 900
120	CONTINUE
C
C	Scan through the index file looking for the 'selected'
C	files.
C
	DIRMAX = 1
	DIRLEN(1) = 3
	DIRNAME(1)(1:DIRLEN(1)) = '0,0'
	IND = RESMAX
C
C	Use the Bitmap to find the next active file header
C
200	CONTINUE
	ISTAT = LIB$FFS(IND,32,IBMAP(0),II)
	IF (ISTAT.EQ.%LOC(LIB$_NOTFOU)) THEN
	 IND = II
	ELSE
	 I = II+INDOFF
	 IND = II+1
	 READ(1,REC=I,END=900,ERR=900) IREC
	 IF (.NOT.OKHEADER(IREC)) GOTO 290
	 EFSIZE2(1) = FAT$L_EFBLK(2)
	 EFSIZE2(2) = FAT$L_EFBLK(1)
	 IF (EFSIZE.LT.MINSIZ) GOTO 290
	 IF (EFSIZE.GT.MAXSIZ) GOTO 290
	 IF ((.NOT.ANYGRP).AND.(UIC2(2).NE.FH2$W_UICGROUP)) GOTO 290
	 IF ((.NOT.ANYMEM).AND.(UIC2(1).NE.FH2$W_UICMEMBER)) GOTO 290
C
C	Copy the filename and FID
C
	 FIDNUM = FH2$W_FID_NUM
	 FIDSEQ = FH2$W_FID_SEQ
	 FIDRVN = FH2$W_FID_RVN
	 GROUP  = FH2$W_UICGROUP
	 MEMBER = FH2$W_UICMEMBER
	 ALSIZE2(1) = FAT$L_HIBLK(2)
	 ALSIZE2(2) = FAT$L_HIBLK(1)
	 J = FH2$B_IDOFFSET*2+FI2$T_FILENAME
	 DO K=J,J+19
	  IF (CHAR(IREC(K)).EQ.' ') THEN
	   BFILEL = K-J
	   GOTO 210
	  ELSE
	   BFILE(K-J+1) = IREC(K)
	  ENDIF
	 ENDDO
	 BFILEL = 19
210	 CONTINUE
C
C	We have a good file, now find its pathname
C
	 DO DIRIND=1,DIRMAX
	  IF ((FH2$W_BK_FIDNUM.EQ.DIRFID(1,DIRIND)).AND.
	1 (FH2$W_BK_FIDSEQ.EQ.DIRFID(2,DIRIND)).AND.
	2 (FH2$W_BK_FIDRVN.EQ.DIRFID(3,DIRIND))) GOTO 270
	 ENDDO
C
C	Haven't seen the directory yet, determine its pathname,
C	and add it to the list.
C
	 DO SUBIND = 1,7
	  IF (DIRMAX.EQ.10000) GOTO 940
	  DIRMAX = DIRMAX+1
	  DIRFID(1,DIRMAX) = FH2$W_BK_FIDNUM
	  DIRFID(2,DIRMAX) = FH2$W_BK_FIDSEQ
	  DIRFID(3,DIRMAX) = FH2$W_BK_FIDRVN
C
C	Get the header of the directory
C
	  I = INDOFF+FH2$W_BK_FIDNUM-1
	  READ(1,REC=I,END=900,ERR=980) IREC
	  IF (OKHEADER(IREC).AND.
	1  (DIRFID(1,DIRMAX).EQ.FH2$W_FID_NUM).AND.
	2  (DIRFID(2,DIRMAX).EQ.FH2$W_FID_SEQ)) THEN
	   J = FH2$B_IDOFFSET*2
	   DO K=J,J+8
	    IF (CHAR(IREC(K)).EQ.'.') THEN
	     DIRLEN(DIRMAX) = K-J
	     GOTO 220
	    ELSE
	     DIRNAME(DIRMAX)(K-J+1:K-J+1) = CHAR(IREC(K))
	    ENDIF
	   ENDDO
	   DIRLEN(DIRMAX)  = 9
220	   CONTINUE
	  ELSE
C
C	It is a LOST file!!
C
	   DIRNAME(DIRMAX)(1:8) = '**LOST**'
	   DIRLEN(DIRMAX) = 8
	   GOTO 260
	  ENDIF
C
C	Is this directory contained in something we know?
C	If yes, Is it in [0,0]?
C	  If yes, propagate dirnames
C	  If not, propagate to this dir & propagate rest
C	If not, try its parent.
C	Now has test for 'infinite loop' dirs
C
	  DO DIRIND=1,DIRMAX
	   IF ((FH2$W_BK_FIDNUM.EQ.DIRFID(1,DIRIND)).AND.
	1  (FH2$W_BK_FIDSEQ.EQ.DIRFID(2,DIRIND)).AND.
	2  (FH2$W_BK_FIDRVN.EQ.DIRFID(3,DIRIND))) THEN
	    IF (DIRIND.GT.DIRMAX-SUBIND) GOTO 250
	    IF (DIRIND.NE.1) THEN
	     K = DIRLEN(DIRMAX)+DIRLEN(DIRIND)+1
	     DIRNAME(DIRMAX)(1:K) = 
	1     DIRNAME(DIRIND)(1:DIRLEN(DIRIND)) // '.' //
	2     DIRNAME(DIRMAX)(1:DIRLEN(DIRMAX))
	     DIRLEN(DIRMAX) = K
	    ENDIF
	    GOTO 260
	   ENDIF
	  ENDDO
	 ENDDO
	 SUBIND = 7
C
C	Could not find the start of the directory chain
C
250	 CONTINUE
	 IF (DIRMAX.EQ.10000) GOTO 940
	 DIRMAX = DIRMAX+1
	 DIRFID(1,DIRMAX) = FH2$W_BK_FIDNUM
	 DIRFID(2,DIRMAX) = FH2$W_BK_FIDSEQ
	 DIRFID(3,DIRMAX) = FH2$W_BK_FIDRVN
	 DIRNAME(DIRMAX)(1:8) = '**LOST**'
	 DIRLEN(DIRMAX) = 8
	 SUBIND = SUBIND+1
C
C	Now, we have to propagate the names of sub-directories
C
260	CONTINUE
	 DO J=1,SUBIND-1
	  K = DIRLEN(DIRMAX-J)+DIRLEN(DIRMAX-J+1)+1
	  DIRNAME(DIRMAX-J)(1:K) = 
	1  DIRNAME(DIRMAX-J+1)(1:DIRLEN(DIRMAX-J+1)) // '.' //
	2  DIRNAME(DIRMAX-J)(1:DIRLEN(DIRMAX-J))
	  DIRLEN(DIRMAX-J) = K
	 ENDDO
	 DIRIND = DIRMAX-SUBIND+1
C
C	Report the pathname of the file
C	Options on output:
C	UIC is shown if wildcard group or member was specified
C	Pathname of the file is always shown
C	File id is shown if desired
C	Size is shown if desired
C	
270	 CONTINUE
	 IF (ANYGRP.OR.ANYMEM) GOTO 272
271	 CONTINUE
	 WRITE(*,280) DIRNAME(DIRIND)(1:DIRLEN(DIRIND)),SFILE(1:BFILEL)
	 GOTO 273
272	 CONTINUE
	 WRITE(*,281) GROUP,MEMBER,
	1  DIRNAME(DIRIND)(1:DIRLEN(DIRIND)),SFILE(1:BFILEL)
273	 CONTINUE
	 GOTO (290,274,275,276) OUTOPT
274	 CONTINUE
	 WRITE(*,282) FIDNUM,FIDSEQ,FIDRVN
	 GOTO 290
275	 CONTINUE
	 WRITE(*,283) EFSIZE,ALSIZE
	 GOTO 290
276	 CONTINUE
	 WRITE(*,284) FIDNUM,FIDSEQ,FIDRVN,EFSIZE,ALSIZE
280	FORMAT(' [',A,']',A)
281	FORMAT(' [',O3.3,',',O3.3,']  [',A,']',A)
282	FORMAT(' File ID:(',O6.6,',',O6.6,',',O6.6')')
283	FORMAT(' Endfile size:',I6,'    Allocated size:',I6)
284	FORMAT(' File ID:(',O6.6,',',O6.6,',',O6.6')',
	1 '  Endfile size:',I6,'    Allocated size:',I6)
C
	ENDIF
290	CONTINUE
	IF (IND.LE.MAXFILES) GOTO 200
C
C	All done
C
900	CONTINUE
	CLOSE(UNIT=1)
	GOTO 1000
C
C	Too many directories known, too bad
C
940	CONTINUE
	WRITE(*,945)
945	FORMAT(' Program limit of directories exceeded.')
	GOTO 900
C
C	Disk has too many possible headers for this program
C
950	CONTINUE
	WRITE(*,955) LINE(1:LINEL)
955	FORMAT(' The disk ',A,' has too many file headers')
	GOTO 900
C
C	Disk is not ODS-2 structured
C
960	CONTINUE
	WRITE(*,965) LINE(1:LINEL)
965	FORMAT(' The disk ',A,' is not ODS-2 structured')
	GOTO 900
C
C	Error reading the Home block
C
970	CONTINUE
	WRITE(*,975)
975	FORMAT(' Error reading the Home Block.  Aborting run')
	GOTO 900
C
C	Error Reading file
C
980	CONTINUE
	WRITE(*,985) I
985	FORMAT(' Error reading record ',I7,'. Aborting run')
	GOTO 900
C
C	Bad device name
C
990	CONTINUE
	WRITE(*,995) LINE(1:LINEL)
995	FORMAT(' Error opening the file ',A,'[0,0]INDEXF.SYS')
C
1000	CONTINUE
	END

	LOGICAL FUNCTION OKHEADER(AREC)
C
C	A function that will validate a header
C	record and return .TRUE. if it is ok.
C
	IMPLICIT REAL*16 (A-Z)
C
	BYTE AREC(0:511),IREC(0:511)
C
C	Data Definitions for the File Headers
C	FH2$B_IDOFFSET  -- Index to Identification Area
C	FH2$W_SEG_NUM   -- Segment number (0 for primary hdr's)
C	FH2$B_STRUCLEV  -- Structure Level of header
C	FH2$W_FID_NUM   -- File ID Number
C	IREC2           -- Equivalent array for I*2 usage
C	
	BYTE FH2$B_IDOFFSET
	INTEGER*2 FH2$W_SEG_NUM
	BYTE FH2$B_STRUCLEV
	INTEGER*2 FH2$W_FID_NUM
	INTEGER*2 IREC2(256)
C
	EQUIVALENCE (IREC('00'X),FH2$B_IDOFFSET)
	EQUIVALENCE (IREC('04'X),FH2$W_SEG_NUM)
	EQUIVALENCE (IREC('07'X),FH2$B_STRUCLEV)
	EQUIVALENCE (IREC('08'X),FH2$W_FID_NUM)
	EQUIVALENCE (IREC,IREC2)
C
C	Other stuff
C
	INTEGER*2 CHECKSUM
	INTEGER I
C
C	Copy the record since FORTRAN will not equivalence to parameters
C
	DO I=0,511
	 IREC(I) = AREC(I)
	ENDDO
C
C	Validation includes:
C	That it is an ODS-2 header
C	That it is not an extension header
C	That the checksum is ok
C
	IF (FH2$B_STRUCLEV.NE.2) GOTO 100
	IF (FH2$W_SEG_NUM.NE.0) GOTO 100
	IF (FH2$W_FID_NUM.EQ.0) GOTO 100
	CHECKSUM = 0
	DO I=1,255
	 CHECKSUM = CHECKSUM+IREC2(I)
	ENDDO
	IF (CHECKSUM.NE.IREC2(256)) GOTO 100
	OKHEADER = .TRUE.
	RETURN
100	CONTINUE
	OKHEADER = .FALSE.
	END
