$	VFY = 'F$VERIFY(0)
$!	PLOT.COM
$!
$!	v 1.1, incorporating the mechanism to talk to the v2.0
$!		plotter_queue_manager as well as the v1.1
$!		DCL driven despooler
$!
$!	This procedure is not permitted when used from a remote
$!	line or from a batch job.
$!
$	ON CONTROL_Y THEN GOTO STOP_BATCH
$	IF "''F$MODE()" .EQS. "BATCH" THEN GOTO STOP_BATCH
$	ON CONTROL_Y THEN GOTO STOP_REMOTE
$	IF "''F$LOGICAL("TT")" .EQS. "_TTA2:" THEN GOTO STOP_REMOTE
$	IF "''F$LOGICAL("TT")" .EQS. "_TTA3:" THEN GOTO STOP_REMOTE
$	IF "''F$LOGICAL("TT")" .EQS. "_TTA5:" THEN GOTO STOP_REMOTE
$!
$!	Procedure to accept plot file name from user and
$!	invoke a priviledged program to get ahold of the
$!	VERSATEC and plot the file.
$!
$	SET NOON
$	ON CONTROL_Y THEN GOTO EXIT
$!
$!	Is the plotter_mailbox available?
$!
$	pm := 'f$logical("PLOTTER_MAILBOX")
$!
$	at_home := "NO
$	if pm.nes." " then at_home:="YES
$	if .not.at_home then goto decode	! maybe old style will work
$!
$!	mailbox is around, do we want something other than a plot?
$!
$	if 'f$locate("HELP",p1).eq.'f$length(p1) then goto not_help
$	type sys$input
The valid commands are:

PHELP		: to get this message
PLOT		: to spool a plot file pair. format is "PLOT dev:[dir];v"
		  to plot a file in directory [dir] on device dev:, version v
		  (all of which are optional if defaults are acceptable)
PSTATus		: to find out what is in the queue
PABORT n	: to abort pid=n of a file currently being plotted.
PCANcel m	: to remove an entry from the queue
$	goto exit
$ not_help:
$!
$	if 'f$locate("ABORT",p1).eq.'f$length(p1) then goto not_abort
$!
$	message := 'p1'" "'p2'
$	goto send_message
$!
$ not_abort:
$!
$	if 'f$locate("CANCEL",p1).eq.'f$length(p1) then goto not_cancel
$!
$	message := 'p1'" "'p2'
$	goto send_message
$!
$ not_cancel:
$!
$	stat = 'f$locate("STATUS",p1)
$	if stat.ne.0 .or. stat.eq.'f$length(p1) then goto decode
$!
$!	check that we can get status messages
$!
$	ps := 'f$logical("PLOTTER_STATUS")
$	if ps.nes." " then goto get_status
$	write sys$output "Sorry, no status available"
$	goto exit
$!
$ get_status:
$!
$!	control_y can hang the plotter_queue_manager during status
$!
$	set nocontrol_y
$	open/write/err=end_status pl 'pm
$	write/err=end_status pl p1
$!
$	open/read/error=end_status rs 'ps
$!
$ read_status_line:
$!
$	read/end=end_status/error=end_status rs line
$	write sys$output line
$	goto read_status_line
$!
$ end_status:
$!
$	close rs
$	close pl
$	set control_y
$	exit
$!
$ decode:
$!
$	IF P1 .EQS. " " THEN P1:='F$LOGICAL("SYS$DISK")''F$DIRECTORY()
$	P1LEN = 'F$LENGTH(P1) + 1
$DISK:
$	DISKLEN = 'F$LOCATE(":",P1) + 1
$	IF DISKLEN .LT. P1LEN THEN GOTO GETDISK
$	P1 := 'F$LOGICAL("SYS$DISK")''P1
$	P1LEN = 'F$LENGTH(P1) + 1
$	GOTO DISK
$GETDISK:
$	DISK := 'F$EXTRACT(0,DISKLEN,P1)
$	P1LEN = P1LEN - DISKLEN
$	P1 := 'F$EXTRACT(DISKLEN,P1LEN,P1)
$DIRECT:
$	DIRECTLEN = 'F$LOCATE("]",P1) + 1
$	IF DIRECTLEN .LT. P1LEN THEN GOTO GETDIRECT
$	P1 := 'F$DIRECTORY()''P1
$	P1LEN = 'F$LENGTH(P1) + 1
$	GOTO DIRECT
$GETDIRECT:
$	DIRECT := 'F$EXTRACT(0,DIRECTLEN,P1)
$	P1LEN = P1LEN - DIRECTLEN
$	P1 := 'F$EXTRACT(DIRECTLEN,P1LEN,P1)
$!
$!	Now the name part of the file is a constant fixed
$!	by VERSAPLOT so all else that we need is the version.
$!
$VERSION:
$	NAMELEN = 'F$LOCATE(";",P1)
$	IF NAMELEN .LT. P1LEN-1 THEN GOTO GETVERSION
$	P1 := 'P1';0	! If there is no name, make it latest version
$	P1LEN = 'F$LENGTH(P1) + 1
$	GOTO VERSION
$GETVERSION:
$	VERSIONLEN = P1LEN - NAMELEN
$	VERSION := 'F$EXTRACT(NAMELEN,VERSIONLEN,P1)
$!
$!	So now we have the required information for the
$!	files to use
$!
$	THEFILES := 'DISK''DIRECT'*.PLV'VERSION
$!
$	if at_home then goto by_mail
$!
$	RENAME 'THEFILES' 'DISK'[PLOT.HOLDING]
$	WRITE SYS$OUTPUT "The command received was: PLOT ''THEFILES
$EXIT:
$	EXIT
$!
$ by_mail:
$!
$	message:="plot ''thefiles
$!
$ send_message:
$!
$	open/write/error=mail_exit pl 'pm
$	write/error=mail_exit pl message
$!
$ mail_exit:
$!
$	close pl
$	write sys$output "The message sent was: ''message
$	exit
$!
$STOP_BATCH:
$	WRITE SYS$OUTPUT -
 "The PLOT command is not legal when used from a batch session. Good-bye."
$	LOGOFF/FULL
$!
$STOP_REMOTE:
$	WRITE SYS$OUTPUT -
 "The PLOT command is not legal when used from a remote terminal. Good-bye."
$	LOGOFF/FULL
